<?php
/**
 * Webkul MarketingCloud Magento Connector SyncAllProduct Controller
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace Webkul\MarketingCloudMagentoConnector\Controller\Adminhtml\Product;

use Magento\Backend\App\Action;
use Magento\Ui\Component\MassAction\Filter;
use Magento\Framework\Controller\ResultFactory;
use Magento\Catalog\Controller\Adminhtml\Product;
use Magento\Catalog\Model\ResourceModel\Product\CollectionFactory;

class SyncAllProduct extends \Magento\Catalog\Controller\Adminhtml\Product
{
    protected $_scopeConfig;
    /**
     * @param Action\Context $context
     * @param Builder $productBuilder
     * @param \Magento\Catalog\Model\Indexer\Product\Price\Processor $productPriceIndexerProcessor
     * @param Filter $filter
     * @param CollectionFactory $collectionFactory
     */
    public function __construct(
        Filter $filter,
        Product\Builder $productBuilder,
        CollectionFactory $collectionFactory,
        \Magento\Catalog\Model\Product $productModel,
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Message\ManagerInterface $messageManager,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Webkul\MarketingCloudMagentoConnector\Helper\Connection $connection
    ) {
        parent::__construct($context, $productBuilder);
        $this->_filter = $filter;
        $this->_connection = $connection;
        $this->_scopeConfig = $scopeConfig;
        $this->_productModel = $productModel;
        $this->_messageManager = $messageManager;
        $this->_collectionFactory = $collectionFactory;
    }

    public function execute()
    {
        $helper = $this->_connection;
        $params = $this->getRequest()->getParams();
        $productId = $params['productId'];
        $helper = $this->_connection;
        $res = $helper->getSyncProduct([$productId]);
        // die($res);
        if ($res && $res[0]) {
            // $this
            // ->_connection
            // ->eshopsyncLog('Subscriber Export Sucess : '.$subscriberId . ' Exported Successfully to Maketing Cloud');
            
            $this->getResponse()->setHeader('Content-type', 'application/json');
            $this->getResponse()->setBody(1);
        } else {
            // $this
            // ->_connection
            // ->eshopsyncLog('Subscriber Export Error : '.$subscriberId . ' Not Exported '.$res[1]);
            $this->getResponse()->setHeader('Content-type', 'application/json');
            $this->getResponse()->setBody(0);
        }
    }
}
