<?php
/**
 * Webkul MarketingCloudMagentoConnector Connection Helper
 * @category  Webkul
 * @package   Webkul_MarketingCloudMagentoConnector
 * @author    Webkul
 * @copyright Copyright (c) 2010-2017 Webkul Software Private Limited (https://webkul.com)
 * @license   https://store.webkul.com/license.html
 */
namespace  Webkul\MarketingCloudMagentoConnector\Helper;

use\SoapVar;

use \Magento\Catalog\Api\CategoryRepositoryInterface;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\WSSESoap;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_Attribute;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTargetSoapClient;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_SaveOption;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_SaveAction;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_APIProperty;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_DataExtension;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_CreateRequest;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_UpdateOptions;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_SimpleOperators;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_RetrieveRequest;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_SimpleFilterPart;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_RetrieveRequestMsg;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_DataExtensionField;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_DataExtensionObject;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_DataExtensionFieldType;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_Subscriber;
use \Webkul\MarketingCloudMagentoConnector\sfmcApi\ExactTarget_SubscriberList;

class Connection extends \Magento\Search\Helper\Data
{
    protected $_session;
    protected $_encryptor;
    protected $_scopeConfig;
    protected $_priceCurrency;
    public static $mcPwd;
    public static $mcList;
    public static $mcUser;
    public static $mcMode;
    public static $mcAutosync;
    public static $mcSubDomain;
    public static $mcmageUserList;
    protected $_addressFactory;
    protected $_customerFactory;
    protected $subscriberFactory;

    public function __construct(
        \Magento\Backend\Model\Session $session,
        CategoryRepositoryInterface $categoryRepository,
        \Magento\Customer\Model\AddressFactory $addressFactory,
        \Magento\Customer\Model\Group $customerGroupCollection,
        \Magento\Directory\Model\CountryFactory $countryFactory,
        \Magento\Framework\ObjectManagerInterface $objectManager,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Magento\Catalog\Model\ProductRepository $productRepository,
        \Magento\Framework\Encryption\EncryptorInterface $encryptor,
        \Magento\Eav\Api\AttributeSetRepositoryInterface $attributeSet,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Magento\Framework\Pricing\PriceCurrencyInterface $priceCurrency,
        \Magento\Customer\Api\CustomerRepositoryInterface $customerRepository,
        \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory,
        \Magento\CatalogInventory\Model\Stock\StockItemRepository $stockItemRepository
    ) {
        $this->subscriberFactory= $subscriberFactory;
        $this->_session = $session;
        $this->_encryptor = $encryptor;
        $this->_scopeConfig = $scopeConfig;
        $this->_storeManager = $storeManager;
        $this->_attributeSet = $attributeSet;
        $this->_priceCurrency = $priceCurrency;
        $this->_objectManager = $objectManager;
        $this->_countryFactory = $countryFactory;
        $this->_addressFactory = $addressFactory;
        $this->_productRepository = $productRepository;
        $this->_customerRepository = $customerRepository;
        $this->_categoryRepository = $categoryRepository;
        $this->_stockItemRepository = $stockItemRepository;
        $this->_customerGroupCollection = $customerGroupCollection;

        self::$mcPwd = $scopeConfig->getValue('marketingcloud/general/mc_pwd');
        self::$mcUser = $scopeConfig->getValue('marketingcloud/general/mc_user');
        self::$mcMode = $scopeConfig->getValue('marketingcloud/general/mc_mode');
        self::$mcList = $scopeConfig->getValue('marketingcloud/general/mc_list');
        self::$mcSubDomain = $scopeConfig->getValue('marketingcloud/general/mc_subDomain');
        self::$mcAutosync = $scopeConfig->getValue('marketingcloud/general/mc_autosync');
    }

    public function getSession()
    {
        return $this->_session;
    }

    public function checkToken()
    {
        $token = $this->_scopeConfig->getValue('marketingcloud/general/mc_conn_token');
        $systemToken = $this->genarateToken();
        if (isset($token) && $systemToken == $token) {
            $this->getSession()->setMarketingToken($token);
        } else {
            $this->getSession()->setMarketingToken(false);
            return false;
        }
        return true;
    }

    public function genarateToken()
    {
        //$baseUrl = $this->_storeManager->getStore()->getBaseUrl();.
        $mg_host = $_SERVER['SERVER_NAME'];
        $subDomain = $this->_scopeConfig->getValue('marketingcloud/general/mc_subDomain');
        $pass = md5($mg_host.''.$subDomain);
        return $pass;
    }

    public static function marketingCloudsyncLog($message = '')
    {
        if ($message) {
            $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
            $logger = $objectManager->create('Webkul\MarketingCloudMagentoConnector\Logger\MarketingCloudLogger');
            $logger->debug($message);
        }
    }

    public function callMcMethod()
    {
        $listIdResults = array();
        try {
            if (isset(self::$mcUser) && isset(self::$mcPwd)) {
                if (isset(self::$mcSubDomain)) {
                    $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
                } else {
                    $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
                }
                $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
                $client->username = self::$mcUser;
                $client->password = $this->_encryptor->decrypt(self::$mcPwd);
                $rr = new ExactTarget_RetrieveRequest();
                $rr->ObjectType = "List";
                $rr->Properties =  array();
                $rr->Properties[] = "ID";
                $rr->Properties[] = "List.ListName";
                $rr->Options = null;
                $rrm = new ExactTarget_RetrieveRequestMsg();
                $rrm->RetrieveRequest = $rr;
                $results = $client->Retrieve($rrm);
                $listIdResults = $results->Results;
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return $listIdResults;
    }

    public function getLoadProduct($id)
    {
        return $this->_productRepository->getById($id);
    }

    public function getFormatedPrice($price, $currency)
    {
        $precision = 2;  // for displaying price decimals 2 point
        return $this->_priceCurrency->format(
            $price,
            $includeContainer = true,
            $precision,
            $scope = null,
            $currency
        );
    }

    public function getStockItem($productId)
    {
        return $this->_stockItemRepository->get($productId);
    }

    public function getAttributeSetName($product)
    {
        $attributeSetRepository = $this->_attributeSet->get($product->getAttributeSetId());
        return $attributeSetRepository->getAttributeSetName();
    }

    public function getSyncProduct($productIds)
    {
        // $productIds = $collection->getAllIds();
        $msg = '';
        $result= true;
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoProductDE";

            if (!in_array($search, $allDEs)) {
                /*First Create A Data extension*/
                $newde = new ExactTarget_DataExtension();
                $newde->Name = $search;
                $newde->CustomerKey = $search;
                $newde->IsSendable = true;
                $newde->IsTestable = false;
                $newde->SendableDataExtensionField = new ExactTarget_DataExtensionField();
                $newde->SendableDataExtensionField->Name = 'Product ID';
                $newde->SendableSubscriberField = new ExactTarget_Attribute();
                $newde->SendableSubscriberField->Name = 'Subscriber Key';
                $newde->SendableDataExtensionField->value = $search;

                $newde->Fields = array();
                $prodIdfield = new ExactTarget_DataExtensionField();
                $prodIdfield->Name = 'Product ID';
                $prodIdfield->IsPrimaryKey = true;
                $prodIdfield->IsRequired = true;
                $prodIdfield->MaxLength = 100;
                $prodIdfield->MinLength = 0;
                $prodIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodIdfield;

                $prodNamefield = new ExactTarget_DataExtensionField();
                $prodNamefield->Name = 'Product Name';
                $prodNamefield->IsPrimaryKey = false;
                $prodNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodNamefield;

                $prodTypefield = new ExactTarget_DataExtensionField();
                $prodTypefield->Name = 'Product Type';
                $prodTypefield->IsPrimaryKey = false;
                $prodTypefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodTypefield;

                $prodAttributeSetfield = new ExactTarget_DataExtensionField();
                $prodAttributeSetfield->Name = 'Attribute Set';
                $prodAttributeSetfield->IsPrimaryKey = false;
                $prodAttributeSetfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodAttributeSetfield;

                $prodSkufield = new ExactTarget_DataExtensionField();
                $prodSkufield->Name = 'Product Sku';
                $prodSkufield->IsPrimaryKey = false;
                $prodSkufield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodSkufield;

                $prodPricefield = new ExactTarget_DataExtensionField();
                $prodPricefield->Name = 'Price';
                $prodPricefield->IsPrimaryKey = false;
                $prodPricefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodPricefield;

                $prodQuentiryfield = new ExactTarget_DataExtensionField();
                $prodQuentiryfield->Name = 'Quentity';
                $prodQuentiryfield->IsPrimaryKey = false;
                $prodQuentiryfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodQuentiryfield;

                $prodImageUrlfield = new ExactTarget_DataExtensionField();
                $prodImageUrlfield->Name = 'Product Image Url';
                $prodImageUrlfield->IsPrimaryKey = false;
                $prodImageUrlfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $prodImageUrlfield;

                $object = new SoapVar($newde, SOAP_ENC_OBJECT, 'DataExtension', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = null;
                $request->Objects = array($object);
                $results = $client->Create($request);
                /* first entering data in Productdata extension */
                foreach ($productIds as $productId) {
                    $result = true;
                    // if ($product->getTypeID() != "configurable") {
                    $productId              = $productId ?? '--';
                    $product                = $this->getLoadProduct($productId);
                    $productName            = $product->getName() ?? '--';
                    $productSku             = $product->getSku() ?? '--';
                    $productPrice           = $product->getPrice() ?? '--';
                    $productType            = $product->getTypeId() ?? '--';
                    $objectManager          = \Magento\Framework\App\ObjectManager::getInstance();
                    $imageHelper            = $objectManager->get('\Magento\Catalog\Helper\Image');
                    $image_url              = $imageHelper->init($product, 'product_thumbnail_image')->setImageFile($product->getFile())->resize(150, 150)->getUrl();
                    $currencysymbol         = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency               = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $productFormatedPrice   = $this->getFormatedPrice($productPrice, $currency);
                    $StockState             = $objectManager->get('\Magento\CatalogInventory\Api\StockStateInterface');
                    $stockItem              = $product->getExtensionAttributes()->getStockItem();
                    $productQuentity        = $stockItem->getQty() ?? '--';
                    $productAttSetname      = $this->getAttributeSetName($product);

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyId = new ExactTarget_APIProperty();
                    $apiPropertyId->Name="Product ID";
                    $apiPropertyId->Value= $productId;
                    $DE->Keys[] = $apiPropertyId;

                    $apiPropertyProdName = new ExactTarget_APIProperty();
                    $apiPropertyProdName->Name="Product Name";
                    $apiPropertyProdName->Value=ucwords($productName);

                    $apiPropertyProdType = new ExactTarget_APIProperty();
                    $apiPropertyProdType->Name="Product Type";
                    $apiPropertyProdType->Value=ucwords($productType);

                    $apiPropertyProdAttSet = new ExactTarget_APIProperty();
                    $apiPropertyProdAttSet->Name="Attribute Set";
                    $apiPropertyProdAttSet->Value=ucwords($productAttSetname);

                    $apiPropertyProdSku = new ExactTarget_APIProperty();
                    $apiPropertyProdSku->Name="Product Sku";
                    $apiPropertyProdSku->Value=$productSku;

                    $apiPropertyProdPrice = new ExactTarget_APIProperty();
                    $apiPropertyProdPrice->Name="Price";
                    $apiPropertyProdPrice->Value=strip_tags($productFormatedPrice);

                    $apiPropertyProdStockState = new ExactTarget_APIProperty();
                    $apiPropertyProdStockState->Name="Quentity";
                    $apiPropertyProdStockState->Value=$productQuentity;

                    $apiPropertyProdImage = new ExactTarget_APIProperty();
                    $apiPropertyProdImage->Name="Product Image Url";
                    $apiPropertyProdImage->Value='<img src="'.$image_url.'" width="50" height="50" />';

                    $DE->Properties = array($apiPropertyProdName,$apiPropertyProdType,$apiPropertyProdAttSet,$apiPropertyProdSku,$apiPropertyProdPrice,$apiPropertyProdStockState,$apiPropertyProdImage);
                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Product Export Sucess : '.$productId . ' Product Data Extension created and product Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Product Export Error : '.$productId . ' Not Exported '.$msg);
                    }
                    // }
                }
            } else {
                /* second entering data in Productdata extension */
                foreach ($productIds as $productId) {
                    $result = true;

                    // if ($product->getTypeID() != "configurable") {
                    $productId              = $productId ?? '--';
                    $product                = $this->getLoadProduct($productId);
                    $productName            = $product->getName() ?? '--';
                    $productSku             = $product->getSku() ?? '--';
                    $productPrice           = $product->getPrice() ?? '--';
                    $productType            = $product->getTypeId() ?? '--';
                    $objectManager          = \Magento\Framework\App\ObjectManager::getInstance();
                    $imageHelper            = $objectManager->get('\Magento\Catalog\Helper\Image');
                    $image_url              = $imageHelper->init($product, 'product_thumbnail_image')->setImageFile($product->getFile())->resize(150, 150)->getUrl();
                    $currencysymbol         = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency               = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $productFormatedPrice   = $this->getFormatedPrice($productPrice, $currency);
                    $StockState             = $objectManager->get('\Magento\CatalogInventory\Api\StockStateInterface');
                    $stockItem              = $product->getExtensionAttributes()->getStockItem();
                    $productQuentity        = $stockItem->getQty() ?? '--';
                    $productAttSetname      = $this->getAttributeSetName($product);

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyId = new ExactTarget_APIProperty();
                    $apiPropertyId->Name="Product ID";
                    $apiPropertyId->Value= $productId;
                    $DE->Keys[] = $apiPropertyId;

                    $apiPropertyProdName = new ExactTarget_APIProperty();
                    $apiPropertyProdName->Name="Product Name";
                    $apiPropertyProdName->Value=ucwords($productName);

                    $apiPropertyProdType = new ExactTarget_APIProperty();
                    $apiPropertyProdType->Name="Product Type";
                    $apiPropertyProdType->Value=ucwords($productType);

                    $apiPropertyProdAttSet = new ExactTarget_APIProperty();
                    $apiPropertyProdAttSet->Name="Attribute Set";
                    $apiPropertyProdAttSet->Value=ucwords($productAttSetname);

                    $apiPropertyProdSku = new ExactTarget_APIProperty();
                    $apiPropertyProdSku->Name="Product Sku";
                    $apiPropertyProdSku->Value=$productSku;

                    $apiPropertyProdPrice = new ExactTarget_APIProperty();
                    $apiPropertyProdPrice->Name="Price";
                    $apiPropertyProdPrice->Value=strip_tags($productFormatedPrice);

                    $apiPropertyProdStockState = new ExactTarget_APIProperty();
                    $apiPropertyProdStockState->Name="Quentity";
                    $apiPropertyProdStockState->Value=$productQuentity;

                    $apiPropertyProdImage = new ExactTarget_APIProperty();
                    $apiPropertyProdImage->Name="Product Image Url";
                    $apiPropertyProdImage->Value='<img src="'.$image_url.'" width="50" height="50" />';

                    $DE->Properties = array($apiPropertyProdName,$apiPropertyProdType,$apiPropertyProdAttSet,$apiPropertyProdSku,$apiPropertyProdPrice,$apiPropertyProdStockState,$apiPropertyProdImage);
                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);
                        
                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Product Export Sucess : '.$productId . 'Product Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Product Export Error : '.$productId . ' Not Exported '.$msg);
                    }
                    //}
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Product Export Error Exception: Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Product Export Error : Not Exported '.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
                ->marketingCloudsyncLog('Product Export Error : Not Exported '.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getSyncCustomer($customerIds)
    {
        // $customerIds = $collection->getAllIds();
        
        $result=true;
        $msg='';
        $custCountry='';
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1,'keep_alive' => false));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
           
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoCustomerDE";
           
            
            
            if (!in_array($search, $allDEs)) {
                /*First Create A Data extension*/
                $newde = new ExactTarget_DataExtension();
                $newde->Name = $search;
                $newde->CustomerKey = $search;
                $newde->IsSendable = true;
                $newde->IsTestable = false;
                $newde->SendableDataExtensionField = new ExactTarget_DataExtensionField();
                $newde->SendableDataExtensionField->Name = 'EMAIL';
                $newde->SendableSubscriberField = new ExactTarget_Attribute();
                $newde->SendableSubscriberField->Name = 'Subscriber Key';
                $newde->SendableDataExtensionField->value = $search;

                $newde->Fields = array();
                $emailfield = new ExactTarget_DataExtensionField();
                $emailfield->Name = 'EMAIL';
                $emailfield->IsPrimaryKey = true;
                $emailfield->IsRequired = true;
                $emailfield->FieldType = ExactTarget_DataExtensionFieldType::EmailAddress;
                $newde->Fields[] = $emailfield;

                $idfield = new ExactTarget_DataExtensionField();
                $idfield->Name = 'ID';
                $idfield->IsPrimaryKey = false;
                $idfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $idfield;

                $namefield = new ExactTarget_DataExtensionField();
                $namefield->Name = 'Name';
                $namefield->IsPrimaryKey = false;
                $namefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $namefield;

                $userGroupfield = new ExactTarget_DataExtensionField();
                $userGroupfield->Name = 'Group';
                $userGroupfield->IsPrimaryKey = false;
                $userGroupfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $userGroupfield;

                $phonefield = new ExactTarget_DataExtensionField();
                $phonefield->Name = 'Phone';
                $phonefield->IsPrimaryKey = false;
                $phonefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $phonefield;

                $zipfield = new ExactTarget_DataExtensionField();
                $zipfield->Name = 'PostalCode';
                $zipfield->IsPrimaryKey = false;
                $zipfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $zipfield;

                $countryfield = new ExactTarget_DataExtensionField();
                $countryfield->Name = 'Country';
                $countryfield->IsPrimaryKey = false;
                $countryfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $countryfield;

                $regionfield = new ExactTarget_DataExtensionField();
                $regionfield->Name = 'Region';
                $regionfield->IsPrimaryKey = false;
                $regionfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $regionfield;

                $dobfield = new ExactTarget_DataExtensionField();
                $dobfield->Name = 'DOB';
                $dobfield->IsPrimaryKey = false;
                $dobfield->FieldType = ExactTarget_DataExtensionFieldType::Date;
                $newde->Fields[] = $dobfield;

                $genderfield = new ExactTarget_DataExtensionField();
                $genderfield->Name = 'Gender';
                $genderfield->IsPrimaryKey = false;
                $genderfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $genderfield;
               
                $object = new SoapVar($newde, SOAP_ENC_OBJECT, 'DataExtension', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = null;
                $request->Objects = array($object);
                $results = $client->Create($request);

                /* First Time data Entry into Table */
                foreach ($customerIds as $customerId) {
                    $result = true;
                    $customer = $this->_customerRepository->getById($customerId);
                    if ($customer->getId()) {
                        $custId = $customer->getId();
                        if ($customer->getFirstname()!=null && $customer->getMiddlename()!=null && $customer->getLastname()!=null) {
                            $custName = $customer->getFirstname().' '.$customer->getMiddlename().' '.$customer->getLastname();
                        } else {
                            $custName = $customer->getFirstname().' '.$customer->getLastname();
                        }
                        $custEmail =  $customer->getEmail() ?? '--';
                        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                        $genderObj = $objectManager->create('Magento\Customer\Model\Customer')->load($customerId);
                        $gender = $genderObj->getResource()->getAttribute('gender')->getSource()->getOptionText($genderObj->getData('gender')) ?? '--';

                        $custDob = $customer->getDob() ?? null;
                        $customerGroupId = $customer->getGroupId();
                        $collection = $this->_customerGroupCollection->load($customerGroupId);
                        $custGroup = $collection->getCustomerGroupCode() ?? '--'; //Get group name
                        $billingAddressId = $customer->getDefaultBilling();
                        $billingAddress = $this->_addressFactory->create()->load($billingAddressId);
                        $custPhone = $billingAddress->getTelephone() ?? '--';
                        $custZip =  $billingAddress->getPostcode() ?? '--';
                        $countryCode = $billingAddress->getCountryId();

                        if (isset($countryCode) && $countryCode!=null) {
                            $custCountry = $this->getCountryname($countryCode) ?? '--';
                        }
                        $custRegion = $billingAddress->getRegion() ?? '--';

                        $DE = new ExactTarget_DataExtensionObject();
                        $DE->Name=$search;

                        $apiPropertyEmail = new ExactTarget_APIProperty();
                        $apiPropertyEmail->Name="EMAIL";
                        $apiPropertyEmail->Value= $custEmail;
                        $DE->Keys[] = $apiPropertyEmail;

                        $apiPropertyId = new ExactTarget_APIProperty();
                        $apiPropertyId->Name="ID";
                        $apiPropertyId->Value='#'.$custId;

                        $apiPropertyName = new ExactTarget_APIProperty();
                        $apiPropertyName->Name="Name";
                        $apiPropertyName->Value=ucwords($custName);

                        $apiPropertyGroup = new ExactTarget_APIProperty();
                        $apiPropertyGroup->Name="Group";
                        $apiPropertyGroup->Value=ucwords($custGroup);

                        $apiPropertyPhone = new ExactTarget_APIProperty();
                        $apiPropertyPhone->Name="Phone";
                        $apiPropertyPhone->Value=$custPhone;

                        $apiPropertyPostalCode = new ExactTarget_APIProperty();
                        $apiPropertyPostalCode->Name="PostalCode";
                        $apiPropertyPostalCode->Value=$custZip;

                        $apiPropertyCountry = new ExactTarget_APIProperty();
                        $apiPropertyCountry->Name="Country";
                        $apiPropertyCountry->Value=$custCountry;

                        $apiPropertyRegion = new ExactTarget_APIProperty();
                        $apiPropertyRegion->Name="Region";
                        $apiPropertyRegion->Value=$custRegion;

                        $apiPropertyDOB = new ExactTarget_APIProperty();
                        $apiPropertyDOB->Name="DOB";
                        $apiPropertyDOB->Value=$custDob;

                        $apiPropertyGender = new ExactTarget_APIProperty();
                        $apiPropertyGender->Name="Gender";
                        $apiPropertyGender->Value=$gender;

                        $DE->Properties=array($apiPropertyId,$apiPropertyName,$apiPropertyGroup,$apiPropertyPhone,$apiPropertyPostalCode,$apiPropertyCountry,$apiPropertyRegion,$apiPropertyDOB,$apiPropertyGender);
                        $so = new ExactTarget_SaveOption();
                        $so->PropertyName = "*";
                        $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                        $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                        $opts = new ExactTarget_UpdateOptions();
                        $opts->SaveOptions = array($soe);

                        $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                        $request = new ExactTarget_CreateRequest();
                        $request->Options = $opts;
                        $request->Objects = array($object);
                        $outputs = $client->Update($request);
                       
                        if (!empty($outputs->Results->StatusCode)) {
                            if ($outputs->Results->StatusCode == 'Error') {
                                $result = false;
                                $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                            }
                        }
                        if ($result) {
                            $this
                            ->marketingCloudsyncLog('Customer Export Sucess : '.$customerId . ' Customer Data Extension created and customer Exported Successfully to Maketing Cloud');
                        } else {
                            $this
                            ->marketingCloudsyncLog('Customer Export Error : '.$customerId . ' Not Exported '.$msg);
                        }
                    }
                }
            } else {
                /* Second Time data insert into Table */
                foreach ($customerIds as $customerId) {
                    $customer = $this->_customerRepository->getById($customerId);
                    $result = true;
                    if ($customer->getId()) {
                        $custId = $customer->getId();
                        if ($customer->getFirstname()!=null && $customer->getMiddlename()!=null && $customer->getLastname()!=null) {
                            $custName = $customer->getFirstname().' '.$customer->getMiddlename().' '.$customer->getLastname();
                        } else {
                            $custName = $customer->getFirstname().' '.$customer->getLastname();
                        }
                        $custEmail =  $customer->getEmail() ?? '--';
                        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                        $genderObj = $objectManager->create('Magento\Customer\Model\Customer')->load($customerId);
                        $gender = $genderObj->getResource()->getAttribute('gender')->getSource()->getOptionText($genderObj->getData('gender')) ?? '--';

                        $custDob = $customer->getDob() ?? null;
                        $customerGroupId = $customer->getGroupId();
                        $collection = $this->_customerGroupCollection->load($customerGroupId);
                        $custGroup = $collection->getCustomerGroupCode() ?? '--'; //Get group name
                        $billingAddressId = $customer->getDefaultBilling();
                        $billingAddress = $this->_addressFactory->create()->load($billingAddressId);
                        $custPhone = $billingAddress->getTelephone() ?? '--';
                        $custZip =  $billingAddress->getPostcode() ?? '--';
                        $countryCode = $billingAddress->getCountryId();
                        
                        if (isset($countryCode) && $countryCode!=null) {
                            $custCountry = $this->getCountryname($countryCode) ?? '--';
                        }
                        $custRegion = $billingAddress->getRegion() ?? '--';

                        $DE = new ExactTarget_DataExtensionObject();
                        $DE->Name = $search;
                       
                        $apiPropertyEmail = new ExactTarget_APIProperty();
                        $apiPropertyEmail->Name="EMAIL";
                        $apiPropertyEmail->Value= $custEmail;
                        $DE->Keys[] = $apiPropertyEmail;

                        $apiPropertyId = new ExactTarget_APIProperty();
                        $apiPropertyId->Name="ID";
                        $apiPropertyId->Value='#'.$custId;

                        $apiPropertyName = new ExactTarget_APIProperty();
                        $apiPropertyName->Name="Name";
                        $apiPropertyName->Value=ucwords($custName);

                        $apiPropertyGroup = new ExactTarget_APIProperty();
                        $apiPropertyGroup->Name="Group";
                        $apiPropertyGroup->Value=ucwords($custGroup);

                        $apiPropertyPhone = new ExactTarget_APIProperty();
                        $apiPropertyPhone->Name="Phone";
                        $apiPropertyPhone->Value=$custPhone;

                        $apiPropertyPostalCode = new ExactTarget_APIProperty();
                        $apiPropertyPostalCode->Name="PostalCode";
                        $apiPropertyPostalCode->Value=$custZip;

                        $apiPropertyCountry = new ExactTarget_APIProperty();
                        $apiPropertyCountry->Name="Country";
                        $apiPropertyCountry->Value=$custCountry;

                        $apiPropertyRegion = new ExactTarget_APIProperty();
                        $apiPropertyRegion->Name="Region";
                        $apiPropertyRegion->Value=$custRegion;

                        $apiPropertyDOB = new ExactTarget_APIProperty();
                        $apiPropertyDOB->Name="DOB";
                        $apiPropertyDOB->Value=$custDob;

                        $apiPropertyGender = new ExactTarget_APIProperty();
                        $apiPropertyGender->Name="Gender";
                        $apiPropertyGender->Value=$gender;

                        $DE->Properties=array($apiPropertyId,$apiPropertyName,$apiPropertyGroup,$apiPropertyPhone,$apiPropertyPostalCode,$apiPropertyCountry,$apiPropertyRegion,$apiPropertyDOB,$apiPropertyGender);
                        
                        $so = new ExactTarget_SaveOption();
                        $so->PropertyName = "*";
                        $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                        $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                        $opts = new ExactTarget_UpdateOptions();
                        $opts->SaveOptions = array($soe);
                        
                        $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                        
                        $request = new ExactTarget_CreateRequest();

                        
                        $request->Options = $opts;
                        $request->Objects = array($object);
                        $outputs = $client->Update($request);
                        
                        if (!empty($outputs->Results->StatusCode)) {
                            if ($outputs->Results->StatusCode == 'Error') {
                                $result = false;
                                $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                            }
                        }
                        if ($result) {
                            $this
                            ->marketingCloudsyncLog('Customer Export Sucess : '.$customerId . ' Exported Successfully to Maketing Cloud');
                        } else {
                            $this
                            ->marketingCloudsyncLog('Customer Export Error : '.$customerId . ' Not Exported '.$msg);
                        }
                    }
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this->marketingCloudsyncLog('Customer Export Error : Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this->marketingCloudsyncLog('Customer Export Error : Not Exported '.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this->marketingCloudsyncLog('Customer Export Error : Not Exported '.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getCountryname($countryCode)
    {
        $country = $this->_countryFactory->create()->loadByCode($countryCode);
        return $country->getName();
    }

    public function getSyncAllOrder($exportIds)
    {
        $msg = '';
        $result= true;
        $purchasedQuentity='';
        $prodName='';
        $strArr = array();
        $str='';
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoOrderDE";
            if (!in_array($search, $allDEs)) {
                /*First Create A Data extension*/
                $newde = new ExactTarget_DataExtension();
                $newde->Name = $search;
                $newde->CustomerKey = $search;
                $newde->IsSendable = true;
                $newde->IsTestable = false;
                $newde->SendableDataExtensionField = new ExactTarget_DataExtensionField();
                $newde->SendableDataExtensionField->Name = 'OrderID';
                $newde->SendableSubscriberField = new ExactTarget_Attribute();
                $newde->SendableSubscriberField->Name = 'Subscriber Key';
                $newde->SendableDataExtensionField->value = $search;

                $newde->Fields = array();
                $orderIdfield = new ExactTarget_DataExtensionField();
                $orderIdfield->Name = 'OrderID';
                $orderIdfield->IsPrimaryKey = true;
                $orderIdfield->IsRequired = true;
                $orderIdfield->MaxLength = 100;
                $orderIdfield->MinLength = 0;
                $orderIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $orderIdfield;

                $billToNamefield = new ExactTarget_DataExtensionField();
                $billToNamefield->Name = 'BillToName';
                $billToNamefield->IsPrimaryKey = false;
                $billToNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $billToNamefield;

                $shipToNamefield = new ExactTarget_DataExtensionField();
                $shipToNamefield->Name = 'ShipToName';
                $shipToNamefield->IsPrimaryKey = false;
                $shipToNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $shipToNamefield;

                $custEmailfield = new ExactTarget_DataExtensionField();
                $custEmailfield->Name = 'CustomerEmail';
                $custEmailfield->IsPrimaryKey = false;
                $custEmailfield->FieldType = ExactTarget_DataExtensionFieldType::EmailAddress;
                $newde->Fields[] = $custEmailfield;

                $purchasedfield = new ExactTarget_DataExtensionField();
                $purchasedfield->Name = 'Purchased';
                $purchasedfield->IsPrimaryKey = false;
                $purchasedfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $purchasedfield;

                $productsfield = new ExactTarget_DataExtensionField();
                $productsfield->Name = 'ProductsName';
                $productsfield->IsPrimaryKey = false;
                $productsfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $productsfield;

                $grandTotalfield = new ExactTarget_DataExtensionField();
                $grandTotalfield->Name = 'GrandTotal';
                $grandTotalfield->IsPrimaryKey = false;
                $grandTotalfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $grandTotalfield;

                $orderStatusfield = new ExactTarget_DataExtensionField();
                $orderStatusfield->Name = 'OrderStatus';
                $orderStatusfield->IsPrimaryKey = false;
                $orderStatusfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $orderStatusfield;

                $paymentMethodfield = new ExactTarget_DataExtensionField();
                $paymentMethodfield->Name = 'PaymentMethod';
                $paymentMethodfield->IsPrimaryKey = false;
                $paymentMethodfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $paymentMethodfield;

                $shipMethodfield = new ExactTarget_DataExtensionField();
                $shipMethodfield->Name = 'ShipmentMethod';
                $shipMethodfield->IsPrimaryKey = false;
                $shipMethodfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $shipMethodfield;

                $billAddfield = new ExactTarget_DataExtensionField();
                $billAddfield->Name = 'BillingAddress';
                $billAddfield->IsPrimaryKey = false;
                $billAddfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $billAddfield;

                $shipAddfield = new ExactTarget_DataExtensionField();
                $shipAddfield->Name = 'ShippingAddress';
                $shipAddfield->IsPrimaryKey = false;
                $shipAddfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $shipAddfield;

                $createdfield = new ExactTarget_DataExtensionField();
                $createdfield->Name = 'OrderCreatedAt';
                $createdfield->IsPrimaryKey = false;
                $createdfield->FieldType = ExactTarget_DataExtensionFieldType::Date;
                $newde->Fields[] = $createdfield;

                $object = new SoapVar($newde, SOAP_ENC_OBJECT, 'DataExtension', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = null;
                $request->Objects = array($object);
                $results = $client->Create($request);
                /* First Time Insert data into table */
                foreach ($exportIds as $orderId) {
                    $result = true;
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $order = $objectManager->create('Magento\Sales\Model\Order')->load($orderId);
                    //Loop through each item and fetch data
                    $orderId = $order->getIncrementId();
                    // Get Billing Information
                    $billingAddress = $order->getBillingAddress();
                    $billToName = '';
                    $billFName = $billingAddress->getFirstname() ?? '--';
                    $billLName = $billingAddress->getLastname() ?? '--';
                    $billToName = $billFName.' '.$billLName;
                    // Get Shipping Information
                    $shippingAddress = $order->getShippingAddress();
                    $shipToName ='';
                    $shipFName = $shippingAddress->getFirstname() ?? '--';
                    $shipLName = $shippingAddress->getLastname() ?? '--';
                    $shipToName = $shipFName.' '.$shipLName;
                    //fetch customer information
                    $custEmail = $order->getCustomerEmail() ?? 'noreply@xyz.com';
                    //Fetch Purchased Quentity
                    foreach ($order->getAllItems() as $key => $item) {
                        $purchasedQuentity = $item->getQtyOrdered() ?? '--';
                        $prodName = $item->getName() ?? '';
                        $strArr[$key] = $prodName;
                    }
                    $str = implode(',', $strArr);
                    $grandTotal = $order->getGrandTotal() ?? '0.0';
                    $currencysymbol     = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency           = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $formatedGrandTotal = $this->getFormatedPrice($order->getGrandTotal(), $currency);
                    //fetch Order Status
                    $orderStatus = $order->getStatus() ?? '--';
                    //fetch payment method
                    $paymentMethod = $order->getPayment()->getAdditionalInformation('method_title') ?? '--';
                    //fetch Shipment method
                    $shipmentMethodName='';
                    $shipmentMethod = $order->getShippingMethod() ?? '--';
                    $shipmentMethodName = str_replace('_', ' ', $shipmentMethod);
                    //fetch billing address
                    $billAdd = '';
                    $billingAddress = $order->getBillingAddress();
                    $billEmail = $billingAddress->getEmail() ?? '';
                    $billTell  = $billingAddress->getTelephone() ?? '';
                    $billCity =  $billingAddress->getCity() ?? '';
                    $billRegine = $billingAddress->getRegion() ?? '';
                    $cuntryCode = $billingAddress->getCountryId() ?? '';
                    $billAdd = $billToName.' '.'<br>'.$billEmail.' '.'<br>'.$billCity.' ' .$billRegine.' '.$cuntryCode.' '.'<br>'.$billTell;

                    //fetch shipping address
                    $shippingAddress = $order->getShippingAddress();
                    $shippAdd = '';
                    $shipEmail = $shippingAddress->getEmail() ?? '';
                    $shipTell = $shippingAddress->getTelephone() ?? '';
                    $shipCity = $shippingAddress->getCity() ?? '';
                    $shipRegion = $shippingAddress->getRegion() ?? '';
                    $shipCountry = $shippingAddress->getCountryId() ?? '';
                    $shippAdd = $shipToName.' '.'<br>'.$shipEmail.' '.'<br>'.$shipCity.' ' .$shipRegion.' '.$shipCountry.' '.'<br>'.$shipTell;

                    //fetch Order Created date
                    $orderCreatedAt = $order->getCreatedAt() ?? '';

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyOrderID = new ExactTarget_APIProperty();
                    $apiPropertyOrderID->Name="OrderID";
                    $apiPropertyOrderID->Value= $orderId;
                    $DE->Keys[] = $apiPropertyOrderID;

                    $apiPropertyBillToName = new ExactTarget_APIProperty();
                    $apiPropertyBillToName->Name="BillToName";
                    $apiPropertyBillToName->Value=ucwords($billToName);

                    $apiPropertyShipToName = new ExactTarget_APIProperty();
                    $apiPropertyShipToName->Name="ShipToName";
                    $apiPropertyShipToName->Value=ucwords($shipToName);

                    $apiPropertyCustEmail = new ExactTarget_APIProperty();
                    $apiPropertyCustEmail->Name="CustomerEmail";
                    $apiPropertyCustEmail->Value=$custEmail;

                    $apiPropertyPurchased = new ExactTarget_APIProperty();
                    $apiPropertyPurchased->Name="Purchased";
                    $apiPropertyPurchased->Value=intval($purchasedQuentity);

                    $apiPropertyOrderProducts = new ExactTarget_APIProperty();
                    $apiPropertyOrderProducts->Name="ProductsName";
                    $apiPropertyOrderProducts->Value=$str;

                    $apiPropertyGrandTotal = new ExactTarget_APIProperty();
                    $apiPropertyGrandTotal->Name="GrandTotal";
                    $apiPropertyGrandTotal->Value=strip_tags($formatedGrandTotal);

                    $apiPropertyOrderStatus = new ExactTarget_APIProperty();
                    $apiPropertyOrderStatus->Name="OrderStatus";
                    $apiPropertyOrderStatus->Value=$orderStatus;

                    $apiPropertyPaymentMethod = new ExactTarget_APIProperty();
                    $apiPropertyPaymentMethod->Name="PaymentMethod";
                    $apiPropertyPaymentMethod->Value=$paymentMethod;

                    $apiPropertyShipmentMethod= new ExactTarget_APIProperty();
                    $apiPropertyShipmentMethod->Name="ShipmentMethod";
                    $apiPropertyShipmentMethod->Value=ucwords($shipmentMethodName);

                    $apiPropertyBillAdd = new ExactTarget_APIProperty();
                    $apiPropertyBillAdd->Name="BillingAddress";
                    $apiPropertyBillAdd->Value=strip_tags($billAdd);

                    $apiPropertyShipAdd = new ExactTarget_APIProperty();
                    $apiPropertyShipAdd->Name="ShippingAddress";
                    $apiPropertyShipAdd->Value=strip_tags($shippAdd);

                    $apiPropertyCreated = new ExactTarget_APIProperty();
                    $apiPropertyCreated->Name="OrderCreatedAt";
                    $apiPropertyCreated->Value=$orderCreatedAt;

                    $DE->Properties = array($apiPropertyBillToName,$apiPropertyShipToName,$apiPropertyCustEmail,$apiPropertyPurchased,$apiPropertyOrderProducts,$apiPropertyGrandTotal,$apiPropertyOrderStatus,$apiPropertyPaymentMethod,$apiPropertyShipmentMethod,$apiPropertyBillAdd,$apiPropertyShipAdd,$apiPropertyCreated);

                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Order Export Sucess : '.$orderId . ' Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Order Export Error : '.$orderId . ' Not Exported '.$msg);
                    }
                }
            } else {
                /* First Time Insert data into table */
                foreach ($exportIds as $orderId) {
                    $result = true;
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $order = $objectManager->create('Magento\Sales\Model\Order')->load($orderId);
                    //Loop through each item and fetch data

                    $orderId = $order->getIncrementId();
                    // Get Billing Information
                    $billingAddress = $order->getBillingAddress();
                    $billToName = '';
                    $billFName = $billingAddress->getFirstname() ?? '--';
                    $billLName = $billingAddress->getLastname() ?? '--';
                    $billToName = $billFName.' '.$billLName;
                    // Get Shipping Information
                    $shippingAddress = $order->getShippingAddress();
                    $shipToName ='';
                    $shipFName = $shippingAddress->getFirstname() ?? '--';
                    $shipLName = $shippingAddress->getLastname() ?? '--';
                    $shipToName = $shipFName.' '.$shipLName;
                    //fetch customer information
                    $custEmail = $order->getCustomerEmail() ?? 'noreply@xyz.com';
                    //Fetch Purchased Quentity
                    foreach ($order->getAllItems() as $key => $item) {
                        $purchasedQuentity = $item->getQtyOrdered() ?? '--';
                        $prodName = $item->getName() ?? '';
                        $strArr[$key] = $prodName;
                    }
                    $str = implode(',', $strArr);
                    // fetch Grand total(Purchased)
                    $grandTotal = $order->getGrandTotal() ?? '0.0';

                    $currencysymbol     = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency           = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $formatedGrandTotal = $this->getFormatedPrice($order->getGrandTotal(), $currency);
                    //fetch Order Status
                    $orderStatus = $order->getStatus() ?? '--';
                    //fetch payment method
                    $paymentMethod = $order->getPayment()->getAdditionalInformation('method_title') ?? '--';
                    //fetch Shipment method
                    $shipmentMethodName='';
                    $shipmentMethod = $order->getShippingMethod() ?? '--';
                    $shipmentMethodName = str_replace('_', ' ', $shipmentMethod);
                    //fetch billing address
                    $billAdd = '';
                    $billingAddress = $order->getBillingAddress();
                    $billEmail = $billingAddress->getEmail() ?? '';
                    $billTell  = $billingAddress->getTelephone() ?? '';
                    $billCity =  $billingAddress->getCity() ?? '';
                    $billRegine = $billingAddress->getRegion() ?? '';
                    $cuntryCode = $billingAddress->getCountryId() ?? '';
                    $billAdd = $billToName.' '.'<br>'.$billEmail.' '.'<br>'.$billCity.' ' .$billRegine.' '.$cuntryCode.' '.'<br>'.$billTell;
                    //fetch shipping address
                    $shippingAddress = $order->getShippingAddress();
                    $shippAdd = '';
                    $shipEmail = $shippingAddress->getEmail() ?? '';
                    $shipTell = $shippingAddress->getTelephone() ?? '';
                    $shipCity = $shippingAddress->getCity() ?? '';
                    $shipRegion = $shippingAddress->getRegion() ?? '';
                    $shipCountry = $shippingAddress->getCountryId() ?? '';
                    $shippAdd = $shipToName.' '.'<br>'.$shipEmail.' '.'<br>'.$shipCity.' ' .$shipRegion.' '.$shipCountry.' '.'<br>'.$shipTell;
                    //fetch Order Created date
                    $orderCreatedAt = $order->getCreatedAt() ?? '';

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyOrderID = new ExactTarget_APIProperty();
                    $apiPropertyOrderID->Name="OrderID";
                    $apiPropertyOrderID->Value= $orderId;
                    $DE->Keys[] = $apiPropertyOrderID;

                    $apiPropertyBillToName = new ExactTarget_APIProperty();
                    $apiPropertyBillToName->Name="BillToName";
                    $apiPropertyBillToName->Value=ucwords($billToName);

                    $apiPropertyShipToName = new ExactTarget_APIProperty();
                    $apiPropertyShipToName->Name="ShipToName";
                    $apiPropertyShipToName->Value=ucwords($shipToName);

                    $apiPropertyCustEmail = new ExactTarget_APIProperty();
                    $apiPropertyCustEmail->Name="CustomerEmail";
                    $apiPropertyCustEmail->Value=$custEmail;

                    $apiPropertyPurchased = new ExactTarget_APIProperty();
                    $apiPropertyPurchased->Name="Purchased";
                    $apiPropertyPurchased->Value=intval($purchasedQuentity);

                    $apiPropertyOrderProducts = new ExactTarget_APIProperty();
                    $apiPropertyOrderProducts->Name="ProductsName";
                    $apiPropertyOrderProducts->Value=$str;

                    $apiPropertyGrandTotal = new ExactTarget_APIProperty();
                    $apiPropertyGrandTotal->Name="GrandTotal";
                    $apiPropertyGrandTotal->Value=strip_tags($formatedGrandTotal);

                    $apiPropertyOrderStatus = new ExactTarget_APIProperty();
                    $apiPropertyOrderStatus->Name="OrderStatus";
                    $apiPropertyOrderStatus->Value=$orderStatus;

                    $apiPropertyPaymentMethod = new ExactTarget_APIProperty();
                    $apiPropertyPaymentMethod->Name="PaymentMethod";
                    $apiPropertyPaymentMethod->Value=$paymentMethod;

                    $apiPropertyShipmentMethod= new ExactTarget_APIProperty();
                    $apiPropertyShipmentMethod->Name="ShipmentMethod";
                    $apiPropertyShipmentMethod->Value=ucwords($shipmentMethodName);

                    $apiPropertyBillAdd = new ExactTarget_APIProperty();
                    $apiPropertyBillAdd->Name="BillingAddress";
                    $apiPropertyBillAdd->Value=strip_tags($billAdd);

                    $apiPropertyShipAdd = new ExactTarget_APIProperty();
                    $apiPropertyShipAdd->Name="ShippingAddress";
                    $apiPropertyShipAdd->Value=strip_tags($shippAdd);

                    $apiPropertyCreated = new ExactTarget_APIProperty();
                    $apiPropertyCreated->Name="OrderCreatedAt";
                    $apiPropertyCreated->Value=$orderCreatedAt;

                    $DE->Properties = array($apiPropertyBillToName,$apiPropertyShipToName,$apiPropertyCustEmail,$apiPropertyPurchased,$apiPropertyOrderProducts,$apiPropertyGrandTotal,$apiPropertyOrderStatus,$apiPropertyPaymentMethod,$apiPropertyShipmentMethod,$apiPropertyBillAdd,$apiPropertyShipAdd,$apiPropertyCreated);

                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Order Export Sucess : '.$orderId . ' Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Order Export Error : '.$orderId . ' Not Exported '.$msg);
                    }
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Order Export Error Exception: Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Order Export Error ContextErrorException: Not Exported '.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
            ->marketingCloudsyncLog('Order Export Error SoapFault: Not Exported '.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getSyncOrder($collection)
    {
        $msg = '';
        $result= true;
        $purchasedQuentity='';
        $prodName='';
        $strArr = array();
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoOrderDE";
            if (!in_array($search, $allDEs)) {
                /*First Create A Data extension*/
                $newde = new ExactTarget_DataExtension();
                $newde->Name = $search;
                $newde->CustomerKey = $search;
                $newde->IsSendable = true;
                $newde->IsTestable = false;
                $newde->SendableDataExtensionField = new ExactTarget_DataExtensionField();
                $newde->SendableDataExtensionField->Name = 'OrderID';
                $newde->SendableSubscriberField = new ExactTarget_Attribute();
                $newde->SendableSubscriberField->Name = 'Subscriber Key';
                $newde->SendableDataExtensionField->value = $search;

                $newde->Fields = array();
                $orderIdfield = new ExactTarget_DataExtensionField();
                $orderIdfield->Name = 'OrderID';
                $orderIdfield->IsPrimaryKey = true;
                $orderIdfield->IsRequired = true;
                $orderIdfield->MaxLength = 100;
                $orderIdfield->MinLength = 0;
                $orderIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $orderIdfield;

                $billToNamefield = new ExactTarget_DataExtensionField();
                $billToNamefield->Name = 'BillToName';
                $billToNamefield->IsPrimaryKey = false;
                $billToNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $billToNamefield;

                $shipToNamefield = new ExactTarget_DataExtensionField();
                $shipToNamefield->Name = 'ShipToName';
                $shipToNamefield->IsPrimaryKey = false;
                $shipToNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $shipToNamefield;

                $custEmailfield = new ExactTarget_DataExtensionField();
                $custEmailfield->Name = 'CustomerEmail';
                $custEmailfield->IsPrimaryKey = false;
                $custEmailfield->FieldType = ExactTarget_DataExtensionFieldType::EmailAddress;
                $newde->Fields[] = $custEmailfield;

                $purchasedfield = new ExactTarget_DataExtensionField();
                $purchasedfield->Name = 'Purchased';
                $purchasedfield->IsPrimaryKey = false;
                $purchasedfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $purchasedfield;

                $productsfield = new ExactTarget_DataExtensionField();
                $productsfield->Name = 'ProductsName';
                $productsfield->IsPrimaryKey = false;
                $productsfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $productsfield;

                $grandTotalfield = new ExactTarget_DataExtensionField();
                $grandTotalfield->Name = 'GrandTotal';
                $grandTotalfield->IsPrimaryKey = false;
                $grandTotalfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $grandTotalfield;

                $orderStatusfield = new ExactTarget_DataExtensionField();
                $orderStatusfield->Name = 'OrderStatus';
                $orderStatusfield->IsPrimaryKey = false;
                $orderStatusfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $orderStatusfield;

                $paymentMethodfield = new ExactTarget_DataExtensionField();
                $paymentMethodfield->Name = 'PaymentMethod';
                $paymentMethodfield->IsPrimaryKey = false;
                $paymentMethodfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $paymentMethodfield;

                $shipMethodfield = new ExactTarget_DataExtensionField();
                $shipMethodfield->Name = 'ShipmentMethod';
                $shipMethodfield->IsPrimaryKey = false;
                $shipMethodfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $shipMethodfield;

                $billAddfield = new ExactTarget_DataExtensionField();
                $billAddfield->Name = 'BillingAddress';
                $billAddfield->IsPrimaryKey = false;
                $billAddfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $billAddfield;

                $shipAddfield = new ExactTarget_DataExtensionField();
                $shipAddfield->Name = 'ShippingAddress';
                $shipAddfield->IsPrimaryKey = false;
                $shipAddfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $shipAddfield;

                $createdfield = new ExactTarget_DataExtensionField();
                $createdfield->Name = 'OrderCreatedAt';
                $createdfield->IsPrimaryKey = false;
                $createdfield->FieldType = ExactTarget_DataExtensionFieldType::Date;
                $newde->Fields[] = $createdfield;

                $object = new SoapVar($newde, SOAP_ENC_OBJECT, 'DataExtension', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = null;
                $request->Objects = array($object);
                $results = $client->Create($request);
                /* First Time Insert data into table */
                foreach ($collection as $order) {
                    $result = true;
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $orders = $objectManager->create('Magento\Sales\Api\Data\OrderInterface')->load($order->getId());
                    //Loop through each item and fetch data
                    $orderId = $order->getIncrementId();
                    // Get Billing Information
                    $billingAddress = $order->getBillingAddress();
                    $billToName = '';
                    $billFName = $billingAddress->getFirstname() ?? '--';
                    $billLName = $billingAddress->getLastname() ?? '--';
                    $billToName = $billFName.' '.$billLName;
                    // Get Shipping Information
                    $shippingAddress = $order->getShippingAddress();
                    $shipToName ='';
                    $shipFName = $shippingAddress->getFirstname() ?? '--';
                    $shipLName = $shippingAddress->getLastname() ?? '--';
                    $shipToName = $shipFName.' '.$shipLName;
                    //fetch customer information
                    $custEmail = $order->getCustomerEmail() ?? 'noreply@xyz.com';
                    //Fetch Purchased Quentity
                    foreach ($orders->getAllItems() as $key => $item) {
                        $purchasedQuentity = $item->getQtyOrdered() ?? '--';
                        $prodName = $item->getName() ?? '';
                        $strArr[$key] = $prodName;
                    }
                    $str = implode(',', $strArr);
                   
                    $grandTotal = $order->getGrandTotal() ?? '0.0';
                    $currencysymbol     = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency           = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $formatedGrandTotal = $this->getFormatedPrice($order->getGrandTotal(), $currency);
                    //fetch Order Status
                    $orderStatus = $order->getStatus() ?? '--';
                    //fetch payment method
                    $paymentMethod = $order->getPayment()->getAdditionalInformation('method_title') ?? '--';
                    //fetch Shipment method
                    $shipmentMethodName='';
                    $shipmentMethod = $order->getShippingMethod() ?? '--';
                    $shipmentMethodName = str_replace('_', ' ', $shipmentMethod);
                    //fetch billing address
                    $billAdd = '';
                    $billingAddress = $order->getBillingAddress();
                    $billEmail = $billingAddress->getEmail() ?? '';
                    $billTell  = $billingAddress->getTelephone() ?? '';
                    $billCity =  $billingAddress->getCity() ?? '';
                    $billRegine = $billingAddress->getRegion() ?? '';
                    $cuntryCode = $billingAddress->getCountryId() ?? '';
                    $billAdd = $billToName.' '.'<br>'.$billEmail.' '.'<br>'.$billCity.' ' .$billRegine.' '.$cuntryCode.' '.'<br>'.$billTell;

                    //fetch shipping address
                    $shippingAddress = $order->getShippingAddress();
                    $shippAdd = '';
                    $shipEmail = $shippingAddress->getEmail() ?? '';
                    $shipTell = $shippingAddress->getTelephone() ?? '';
                    $shipCity = $shippingAddress->getCity() ?? '';
                    $shipRegion = $shippingAddress->getRegion() ?? '';
                    $shipCountry = $shippingAddress->getCountryId() ?? '';
                    $shippAdd = $shipToName.' '.'<br>'.$shipEmail.' '.'<br>'.$shipCity.' ' .$shipRegion.' '.$shipCountry.' '.'<br>'.$shipTell;

                    //fetch Order Created date
                    $orderCreatedAt = $order->getCreatedAt() ?? '';

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyOrderID = new ExactTarget_APIProperty();
                    $apiPropertyOrderID->Name="OrderID";
                    $apiPropertyOrderID->Value= $orderId;
                    $DE->Keys[] = $apiPropertyOrderID;

                    $apiPropertyBillToName = new ExactTarget_APIProperty();
                    $apiPropertyBillToName->Name="BillToName";
                    $apiPropertyBillToName->Value=ucwords($billToName);

                    $apiPropertyShipToName = new ExactTarget_APIProperty();
                    $apiPropertyShipToName->Name="ShipToName";
                    $apiPropertyShipToName->Value=ucwords($shipToName);

                    $apiPropertyCustEmail = new ExactTarget_APIProperty();
                    $apiPropertyCustEmail->Name="CustomerEmail";
                    $apiPropertyCustEmail->Value=$custEmail;

                    $apiPropertyPurchased = new ExactTarget_APIProperty();
                    $apiPropertyPurchased->Name="Purchased";
                    $apiPropertyPurchased->Value=intval($purchasedQuentity);

                    $apiPropertyOrderProducts = new ExactTarget_APIProperty();
                    $apiPropertyOrderProducts->Name="ProductsName";
                    $apiPropertyOrderProducts->Value=$str;

                    $apiPropertyGrandTotal = new ExactTarget_APIProperty();
                    $apiPropertyGrandTotal->Name="GrandTotal";
                    $apiPropertyGrandTotal->Value=strip_tags($formatedGrandTotal);

                    $apiPropertyOrderStatus = new ExactTarget_APIProperty();
                    $apiPropertyOrderStatus->Name="OrderStatus";
                    $apiPropertyOrderStatus->Value=$orderStatus;

                    $apiPropertyPaymentMethod = new ExactTarget_APIProperty();
                    $apiPropertyPaymentMethod->Name="PaymentMethod";
                    $apiPropertyPaymentMethod->Value=$paymentMethod;

                    $apiPropertyShipmentMethod= new ExactTarget_APIProperty();
                    $apiPropertyShipmentMethod->Name="ShipmentMethod";
                    $apiPropertyShipmentMethod->Value=ucwords($shipmentMethodName);

                    $apiPropertyBillAdd = new ExactTarget_APIProperty();
                    $apiPropertyBillAdd->Name="BillingAddress";
                    $apiPropertyBillAdd->Value=strip_tags($billAdd);

                    $apiPropertyShipAdd = new ExactTarget_APIProperty();
                    $apiPropertyShipAdd->Name="ShippingAddress";
                    $apiPropertyShipAdd->Value=strip_tags($shippAdd);

                    $apiPropertyCreated = new ExactTarget_APIProperty();
                    $apiPropertyCreated->Name="OrderCreatedAt";
                    $apiPropertyCreated->Value=$orderCreatedAt;

                    $DE->Properties = array($apiPropertyBillToName,$apiPropertyShipToName,$apiPropertyCustEmail,$apiPropertyPurchased,$apiPropertyOrderProducts,$apiPropertyGrandTotal,$apiPropertyOrderStatus,$apiPropertyPaymentMethod,$apiPropertyShipmentMethod,$apiPropertyBillAdd,$apiPropertyShipAdd,$apiPropertyCreated);

                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Order Export Sucess : '.$orderId . ' Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Order Export Error : '.$orderId . ' Not Exported '.$msg);
                    }
                }
            } else {
                /* First Time Insert data into table */
                foreach ($collection as $order) {
                    $result = true;
                    $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $orders = $objectManager->create('Magento\Sales\Api\Data\OrderInterface')->load($order->getId());
                    //Loop through each item and fetch data

                    $orderId = $order->getIncrementId();
                    // Get Billing Information
                    $billingAddress = $order->getBillingAddress();
                    $billToName = '';
                    $billFName = $billingAddress->getFirstname() ?? '--';
                    $billLName = $billingAddress->getLastname() ?? '--';
                    $billToName = $billFName.' '.$billLName;
                    // Get Shipping Information
                    $shippingAddress = $order->getShippingAddress();
                    $shipToName ='';
                    if ($shippingAddress) {
                        $shipFName = $shippingAddress->getFirstname() ?? '--';
                        $shipLName = $shippingAddress->getLastname() ?? '--';
                        $shipToName = $shipFName.' '.$shipLName;
                    } else {
                        $shipToName ='--';
                    }
                    //fetch customer information
                    $custEmail = $order->getCustomerEmail() ?? 'noreply@xyz.com';
                    //Fetch Purchased Quentity
                    foreach ($orders->getAllItems() as $key => $item) {
                        $purchasedQuentity = $item->getQtyOrdered() ?? '--';
                        $prodName = $item->getName() ?? '';
                        $strArr[$key] = $prodName;
                    }
                    $str = implode(',', $strArr);
                    // fetch Grand total(Purchased)
                    $grandTotal = $order->getGrandTotal() ?? '0.0';

                    $currencysymbol     = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency           = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $formatedGrandTotal = $this->getFormatedPrice($order->getGrandTotal(), $currency);
                    //fetch Order Status
                    $orderStatus = $order->getStatus() ?? '--';
                    //fetch payment method
                    $paymentMethod = $order->getPayment()->getAdditionalInformation('method_title') ?? '--';
                    //fetch Shipment method
                    $shipmentMethodName='';
                    $shipmentMethod = $order->getShippingMethod() ?? '--';
                    $shipmentMethodName = str_replace('_', ' ', $shipmentMethod);
                    //fetch billing address
                    $billAdd = '';
                    $billingAddress = $order->getBillingAddress();
                    $billEmail = $billingAddress->getEmail() ?? '';
                    $billTell  = $billingAddress->getTelephone() ?? '';
                    $billCity =  $billingAddress->getCity() ?? '';
                    $billRegine = $billingAddress->getRegion() ?? '';
                    $cuntryCode = $billingAddress->getCountryId() ?? '';
                    $billAdd = $billToName.' '.'<br>'.$billEmail.' '.'<br>'.$billCity.' ' .$billRegine.' '.$cuntryCode.' '.'<br>'.$billTell;
                    //fetch shipping address
                    $shippingAddress = $order->getShippingAddress();
                    $shippAdd = '';
                    $shipEmail = ($shippingAddress) ? $shippingAddress->getEmail() : '';
                    $shipTell = ($shippingAddress) ? $shippingAddress->getTelephone() : '';
                    $shipCity = ($shippingAddress) ? $shippingAddress->getCity() : '';
                    $shipRegion = ($shippingAddress) ? $shippingAddress->getRegion() : '';
                    $shipCountry = ($shippingAddress) ? $shippingAddress->getCountryId() : '';
                    $shippAdd = $shipToName.' '.'<br>'.$shipEmail.' '.'<br>'.$shipCity.' ' .$shipRegion.' '.$shipCountry.' '.'<br>'.$shipTell;
                    //fetch Order Created date
                    $orderCreatedAt = $order->getCreatedAt() ?? '';

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyOrderID = new ExactTarget_APIProperty();
                    $apiPropertyOrderID->Name="OrderID";
                    $apiPropertyOrderID->Value= $orderId;
                    $DE->Keys[] = $apiPropertyOrderID;

                    $apiPropertyBillToName = new ExactTarget_APIProperty();
                    $apiPropertyBillToName->Name="BillToName";
                    $apiPropertyBillToName->Value=ucwords($billToName);

                    $apiPropertyShipToName = new ExactTarget_APIProperty();
                    $apiPropertyShipToName->Name="ShipToName";
                    $apiPropertyShipToName->Value=ucwords($shipToName);

                    $apiPropertyCustEmail = new ExactTarget_APIProperty();
                    $apiPropertyCustEmail->Name="CustomerEmail";
                    $apiPropertyCustEmail->Value=$custEmail;

                    $apiPropertyPurchased = new ExactTarget_APIProperty();
                    $apiPropertyPurchased->Name="Purchased";
                    $apiPropertyPurchased->Value=intval($purchasedQuentity);

                    $apiPropertyOrderProducts = new ExactTarget_APIProperty();
                    $apiPropertyOrderProducts->Name="ProductsName";
                    $apiPropertyOrderProducts->Value=$str;

                    $apiPropertyGrandTotal = new ExactTarget_APIProperty();
                    $apiPropertyGrandTotal->Name="GrandTotal";
                    $apiPropertyGrandTotal->Value=strip_tags($formatedGrandTotal);

                    $apiPropertyOrderStatus = new ExactTarget_APIProperty();
                    $apiPropertyOrderStatus->Name="OrderStatus";
                    $apiPropertyOrderStatus->Value=$orderStatus;

                    $apiPropertyPaymentMethod = new ExactTarget_APIProperty();
                    $apiPropertyPaymentMethod->Name="PaymentMethod";
                    $apiPropertyPaymentMethod->Value=$paymentMethod;

                    $apiPropertyShipmentMethod= new ExactTarget_APIProperty();
                    $apiPropertyShipmentMethod->Name="ShipmentMethod";
                    $apiPropertyShipmentMethod->Value=ucwords($shipmentMethodName);

                    $apiPropertyBillAdd = new ExactTarget_APIProperty();
                    $apiPropertyBillAdd->Name="BillingAddress";
                    $apiPropertyBillAdd->Value=strip_tags($billAdd);

                    $apiPropertyShipAdd = new ExactTarget_APIProperty();
                    $apiPropertyShipAdd->Name="ShippingAddress";
                    $apiPropertyShipAdd->Value=strip_tags($shippAdd);

                    $apiPropertyCreated = new ExactTarget_APIProperty();
                    $apiPropertyCreated->Name="OrderCreatedAt";
                    $apiPropertyCreated->Value=$orderCreatedAt;

                    $DE->Properties = array($apiPropertyBillToName,$apiPropertyShipToName,$apiPropertyCustEmail,$apiPropertyPurchased,$apiPropertyOrderProducts,$apiPropertyGrandTotal,$apiPropertyOrderStatus,$apiPropertyPaymentMethod,$apiPropertyShipmentMethod,$apiPropertyBillAdd,$apiPropertyShipAdd,$apiPropertyCreated);

                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Order Export Sucess : '.$orderId . ' Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Order Export Error : '.$orderId . ' Not Exported '.$msg);
                    }
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Order Export Error Exception : Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Order Export Error ContextErrorException : Not Exported '.$msg);

        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
                ->marketingCloudsyncLog('Order Export Error SoapFault : Not Exported '.$msg);
    
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getAutoSyncProduct($product)
    {
        $msg = '';
        $result= true;
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoProductDE";

            if (in_array($search, $allDEs)) {
                if ($product->getTypeID() != "configurable") {
                    $productId              = $product->getId() ?? '--';
                    $productName            = $product->getName() ?? '--';
                    $productSku             = $product->getSku() ?? '--';
                    $productPrice           = $product->getPrice() ?? '--';
                    $productType            = $product->getTypeId() ?? '--';
                    $objectManager          = \Magento\Framework\App\ObjectManager::getInstance();
                    $imageHelper            = $objectManager->get('\Magento\Catalog\Helper\Image');
                    $image_url              = $imageHelper->init($product, 'product_thumbnail_image')->setImageFile($product->getFile())->resize(150, 150)->getUrl();
                    $currencysymbol         = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                    $currency               = $currencysymbol->getStore()->getCurrentCurrencyCode();
                    $productFormatedPrice   = $this->getFormatedPrice($productPrice, $currency);
                    // $stockItem              = $product->getExtensionAttributes()->getStockItem();
                    // $productQuentity        = $stockItem->getQty() ?? '--';
                    $StockState = $objectManager->get('\Magento\CatalogInventory\Api\StockStateInterface');
                    $productQuentity = $StockState->getStockQty($product->getId(), $product->getStore()->getWebsiteId());
                    $productAttSetname      = $this->getAttributeSetName($product);

                    /*if DE present then insert data into DE */
                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyId = new ExactTarget_APIProperty();
                    $apiPropertyId->Name="Product ID";
                    $apiPropertyId->Value= $productId;
                    $DE->Keys[] = $apiPropertyId;

                    $apiPropertyProdName = new ExactTarget_APIProperty();
                    $apiPropertyProdName->Name="Product Name";
                    $apiPropertyProdName->Value=ucwords($productName);

                    $apiPropertyProdType = new ExactTarget_APIProperty();
                    $apiPropertyProdType->Name="Product Type";
                    $apiPropertyProdType->Value=ucwords($productType);

                    $apiPropertyProdAttSet = new ExactTarget_APIProperty();
                    $apiPropertyProdAttSet->Name="Attribute Set";
                    $apiPropertyProdAttSet->Value=ucwords($productAttSetname);

                    $apiPropertyProdSku = new ExactTarget_APIProperty();
                    $apiPropertyProdSku->Name="Product Sku";
                    $apiPropertyProdSku->Value=$productSku;

                    $apiPropertyProdPrice = new ExactTarget_APIProperty();
                    $apiPropertyProdPrice->Name="Price";
                    $apiPropertyProdPrice->Value=strip_tags($productFormatedPrice);

                    $apiPropertyProdStockState = new ExactTarget_APIProperty();
                    $apiPropertyProdStockState->Name="Quentity";
                    $apiPropertyProdStockState->Value=$productQuentity;

                    $apiPropertyProdImage = new ExactTarget_APIProperty();
                    $apiPropertyProdImage->Name="Product Image Url";
                    $apiPropertyProdImage->Value='<img src="'.$image_url.'" width="50" height="50" />';

                    $DE->Properties = array($apiPropertyProdName,$apiPropertyProdType,$apiPropertyProdAttSet,$apiPropertyProdSku,$apiPropertyProdPrice,$apiPropertyProdStockState,$apiPropertyProdImage);
                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Product Export Sucess : '.$productId . ' Product Data Extension created and product Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Product Export Error : '.$productId . ' Not Exported '.$msg);
                    }
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Product Export Error Exception : Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Product Export Error ContextErrorException'.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
            ->marketingCloudsyncLog('Product Export Error SoapFault'.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getAutoSyncCustomer($customerId)
    {
        $msg = '';
        $result= true;
        $custCountry='';
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoCustomerDE";
            if (in_array($search, $allDEs)) {
                $customer = $this->_customerRepository->getById($customerId);
                $custId = $customer->getId();
                if ($customer->getFirstname()!=null && $customer->getMiddlename()!=null && $customer->getLastname()!=null) {
                    $custName = $customer->getFirstname().' '.$customer->getMiddlename().' '.$customer->getLastname();
                } else {
                    $custName = $customer->getFirstname().' '.$customer->getLastname();
                }
                $custEmail =  $customer->getEmail() ?? '--';
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $genderObj = $objectManager->create('Magento\Customer\Model\Customer')->load($customerId);
                $gender = $genderObj->getResource()->getAttribute('gender')->getSource()->getOptionText($genderObj->getData('gender')) ?? '--';

                $custDob = $customer->getDob() ?? null;
                $customerGroupId = $customer->getGroupId();
                $collection = $this->_customerGroupCollection->load($customerGroupId);
                $custGroup = $collection->getCustomerGroupCode() ?? '--'; //Get group name
                $billingAddressId = $customer->getDefaultBilling();
                $billingAddress = $this->_addressFactory->create()->load($billingAddressId);
                $custPhone = $billingAddress->getTelephone() ?? '--';
                $custZip =  $billingAddress->getPostcode() ?? '--';
                $countryCode = $billingAddress->getCountryId();

                if (isset($countryCode) && $countryCode!=null) {
                    $custCountry = $this->getCountryname($countryCode) ?? '--';
                }
                $custRegion = $billingAddress->getRegion() ?? '--';

                $DE = new ExactTarget_DataExtensionObject();
                $DE->Name=$search;

                $apiPropertyEmail = new ExactTarget_APIProperty();
                $apiPropertyEmail->Name="EMAIL";
                $apiPropertyEmail->Value= $custEmail;
                $DE->Keys[] = $apiPropertyEmail;

                $apiPropertyId = new ExactTarget_APIProperty();
                $apiPropertyId->Name="ID";
                $apiPropertyId->Value='#'.$custId;

                $apiPropertyName = new ExactTarget_APIProperty();
                $apiPropertyName->Name="Name";
                $apiPropertyName->Value=ucwords($custName);

                $apiPropertyGroup = new ExactTarget_APIProperty();
                $apiPropertyGroup->Name="Group";
                $apiPropertyGroup->Value=ucwords($custGroup);

                $apiPropertyPhone = new ExactTarget_APIProperty();
                $apiPropertyPhone->Name="Phone";
                $apiPropertyPhone->Value=$custPhone;

                $apiPropertyPostalCode = new ExactTarget_APIProperty();
                $apiPropertyPostalCode->Name="PostalCode";
                $apiPropertyPostalCode->Value=$custZip;

                $apiPropertyCountry = new ExactTarget_APIProperty();
                $apiPropertyCountry->Name="Country";
                $apiPropertyCountry->Value=$custCountry;

                $apiPropertyRegion = new ExactTarget_APIProperty();
                $apiPropertyRegion->Name="Region";
                $apiPropertyRegion->Value=$custRegion;

                $apiPropertyDOB = new ExactTarget_APIProperty();
                $apiPropertyDOB->Name="DOB";
                $apiPropertyDOB->Value=$custDob;

                $apiPropertyGender = new ExactTarget_APIProperty();
                $apiPropertyGender->Name="Gender";
                $apiPropertyGender->Value=$gender;

                $DE->Properties=array($apiPropertyId,$apiPropertyName,$apiPropertyGroup,$apiPropertyPhone,$apiPropertyPostalCode,$apiPropertyCountry,$apiPropertyRegion,$apiPropertyDOB,$apiPropertyGender);

                $so = new ExactTarget_SaveOption();
                $so->PropertyName = "*";
                $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                $opts = new ExactTarget_UpdateOptions();
                $opts->SaveOptions = array($soe);
                
                $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = $opts;
                $request->Objects = array($object);
                $outputs = $client->Update($request);

                if (!empty($outputs->Results->StatusCode)) {
                    if ($outputs->Results->StatusCode == 'Error') {
                        $result = false;
                        $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                    }
                }
                if ($result) {
                    $this
                    ->marketingCloudsyncLog('Customer Auto Export Sucess : '.$customerId . 'Customer Exported Successfully to Maketing Cloud');
                } else {
                    $this
                    ->marketingCloudsyncLog('Customer Auto Export Error : '.$customerId . ' Not Exported '.$msg);
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Customer Auto Export Exception : Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Customer Auto Export ContextErrorException : Not Exported '.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
            ->marketingCloudsyncLog('Customer Auto Export SoapFault : Not Exported '.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getAutoSyncOrder($orderId)
    {
        $msg = '';
        $result= true;
        $prodName='';
        $strArr = array();
        $str='';
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoOrderDE";
            if (in_array($search, $allDEs)) {
                $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                $order = $objectManager->create('Magento\Sales\Api\Data\OrderInterface')->load($orderId);

                $orderId = $order->getIncrementId();
                // Get Billing Information
                $billingAddress = $order->getBillingAddress();
                $billToName = '';
                $billFName = $billingAddress->getFirstname() ?? '--';
                $billLName = $billingAddress->getLastname() ?? '--';
                $billToName = $billFName.' '.$billLName;
                // Get Shipping Information
                $shippingAddress = $order->getShippingAddress();
                $shipToName ='';
                $shipFName = $shippingAddress->getFirstname() ?? '--';
                $shipLName = $shippingAddress->getLastname() ?? '--';
                $shipToName = $shipFName.' '.$shipLName;
                //fetch customer information
                $custEmail = $order->getCustomerEmail() ?? 'noreply@xyz.com';
                //Fetch Purchased Quentity
                $purchasedQuentity ='';
                foreach ($order->getAllItems() as $key => $item) {
                    $purchasedQuentity = $item->getQtyOrdered() ?? '--';
                    $prodName = $item->getName() ?? '';
                    $strArr[$key] = $prodName;
                }
                $str = implode(',', $strArr);
                // fetch Grand total(Purchased)
                $grandTotal = $order->getGrandTotal() ?? '0.0';
                $currencysymbol     = $objectManager->get('Magento\Store\Model\StoreManagerInterface');
                $currency           = $currencysymbol->getStore()->getCurrentCurrencyCode();
                $formatedGrandTotal = $this->getFormatedPrice($order->getGrandTotal(), $currency);
                //fetch Order Status
                $orderStatus = $order->getStatus() ?? '--';
                //fetch payment method
                $paymentMethod = $order->getPayment()->getAdditionalInformation('method_title') ?? '--';
                //fetch Shipment method
                $shipmentMethodName='';
                $shipmentMethod = $order->getShippingMethod() ?? '--';
                $shipmentMethodName = str_replace('_', ' ', $shipmentMethod);
                //fetch billing address
                $billAdd = '';
                $billingAddress = $order->getBillingAddress();
                $billEmail = $billingAddress->getEmail() ?? '';
                $billTell  = $billingAddress->getTelephone() ?? '';
                $billCity =  $billingAddress->getCity() ?? '';
                $billRegine = $billingAddress->getRegion() ?? '';
                $cuntryCode = $billingAddress->getCountryId() ?? '';
                $billAdd = $billToName.' '.'<br>'.$billEmail.' '.'<br>'.$billCity.' ' .$billRegine.' '.$cuntryCode.' '.'<br>'.$billTell;

                //fetch shipping address
                $shippingAddress = $order->getShippingAddress();
                $shippAdd = '';
                $shipEmail = $shippingAddress->getEmail() ?? '';
                $shipTell = $shippingAddress->getTelephone() ?? '';
                $shipCity = $shippingAddress->getCity() ?? '';
                $shipRegion = $shippingAddress->getRegion() ?? '';
                $shipCountry = $shippingAddress->getCountryId() ?? '';
                $shippAdd = $shipToName.' '.'<br>'.$shipEmail.' '.'<br>'.$shipCity.' ' .$shipRegion.' '.$shipCountry.' '.'<br>'.$shipTell;

                //fetch Order Created date
                $orderCreatedAt = $order->getCreatedAt() ?? '';

                $DE = new ExactTarget_DataExtensionObject();
                $DE->Name=$search;

                $apiPropertyOrderID = new ExactTarget_APIProperty();
                $apiPropertyOrderID->Name="OrderID";
                $apiPropertyOrderID->Value= $orderId;
                $DE->Keys[] = $apiPropertyOrderID;

                $apiPropertyBillToName = new ExactTarget_APIProperty();
                $apiPropertyBillToName->Name="BillToName";
                $apiPropertyBillToName->Value=ucwords($billToName);

                $apiPropertyShipToName = new ExactTarget_APIProperty();
                $apiPropertyShipToName->Name="ShipToName";
                $apiPropertyShipToName->Value=ucwords($shipToName);

                $apiPropertyCustEmail = new ExactTarget_APIProperty();
                $apiPropertyCustEmail->Name="CustomerEmail";
                $apiPropertyCustEmail->Value=$custEmail;

                $apiPropertyPurchased = new ExactTarget_APIProperty();
                $apiPropertyPurchased->Name="Purchased";
                $apiPropertyPurchased->Value=intval($purchasedQuentity);

                $apiPropertyOrderProducts = new ExactTarget_APIProperty();
                $apiPropertyOrderProducts->Name="ProductsName";
                $apiPropertyOrderProducts->Value=$str;

                $apiPropertyGrandTotal = new ExactTarget_APIProperty();
                $apiPropertyGrandTotal->Name="GrandTotal";
                $apiPropertyGrandTotal->Value=strip_tags($formatedGrandTotal);

                $apiPropertyOrderStatus = new ExactTarget_APIProperty();
                $apiPropertyOrderStatus->Name="OrderStatus";
                $apiPropertyOrderStatus->Value=$orderStatus;

                $apiPropertyPaymentMethod = new ExactTarget_APIProperty();
                $apiPropertyPaymentMethod->Name="PaymentMethod";
                $apiPropertyPaymentMethod->Value=$paymentMethod;

                $apiPropertyShipmentMethod= new ExactTarget_APIProperty();
                $apiPropertyShipmentMethod->Name="ShipmentMethod";
                $apiPropertyShipmentMethod->Value=ucwords($shipmentMethodName);

                $apiPropertyBillAdd = new ExactTarget_APIProperty();
                $apiPropertyBillAdd->Name="BillingAddress";
                $apiPropertyBillAdd->Value=strip_tags($billAdd);

                $apiPropertyShipAdd = new ExactTarget_APIProperty();
                $apiPropertyShipAdd->Name="ShippingAddress";
                $apiPropertyShipAdd->Value=strip_tags($shippAdd);

                $apiPropertyCreated = new ExactTarget_APIProperty();
                $apiPropertyCreated->Name="OrderCreatedAt";
                $apiPropertyCreated->Value=$orderCreatedAt;

                $DE->Properties = array($apiPropertyBillToName,$apiPropertyShipToName,$apiPropertyCustEmail,$apiPropertyPurchased,$apiPropertyOrderProducts,$apiPropertyGrandTotal,$apiPropertyOrderStatus,$apiPropertyPaymentMethod,$apiPropertyShipmentMethod,$apiPropertyBillAdd,$apiPropertyShipAdd,$apiPropertyCreated);

                $so = new ExactTarget_SaveOption();
                $so->PropertyName = "*";
                $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                $opts = new ExactTarget_UpdateOptions();
                $opts->SaveOptions = array($soe);

                $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = $opts;
                $request->Objects = array($object);
                $outputs = $client->Update($request);
                if (!empty($outputs->Results->StatusCode)) {
                    if ($outputs->Results->StatusCode == 'Error') {
                        $result = false;
                        $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                    }
                }
                if ($result) {
                    $this
                    ->marketingCloudsyncLog('Order Auto Export Sucess : '.$orderId . ' Exported Successfully to Maketing Cloud');
                } else {
                    $this
                    ->marketingCloudsyncLog('Order Auto Export Error : '.$orderId . ' Not Exported '.$msg);
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this->marketingCloudsyncLog('Order Auto Export Error Exception : Not Exported '.$msg);
            
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this->marketingCloudsyncLog('Order Auto Export Error ContextErrorException : Not Exported '.$msg);

        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this->marketingCloudsyncLog('Order Auto Export Error SoapFault : Not Exported '.$msg);

            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getAutoSyncCategory($category)
    {
        $msg = '';
        $result= true;
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoCategoryDE";
            if (!in_array($search, $allDEs)) {
                $newde = new ExactTarget_DataExtension();
                $newde->Name = $search;
                $newde->CustomerKey = $search;
                $newde->IsSendable = true;
                $newde->IsTestable = false;
                $newde->SendableDataExtensionField = new ExactTarget_DataExtensionField();
                $newde->SendableDataExtensionField->Name = 'CategoryID';
                $newde->SendableSubscriberField = new ExactTarget_Attribute();
                $newde->SendableSubscriberField->Name = 'Subscriber Key';
                $newde->SendableDataExtensionField->value = $search;

                $newde->Fields = array();
                $catIdfield = new ExactTarget_DataExtensionField();
                $catIdfield->Name = 'CategoryID';
                $catIdfield->IsPrimaryKey = true;
                $catIdfield->IsRequired = true;
                $catIdfield->MaxLength = 100;
                $catIdfield->MinLength = 0;
                $catIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catIdfield;

                $catNamefield = new ExactTarget_DataExtensionField();
                $catNamefield->Name = 'CategoryName';
                $catNamefield->IsPrimaryKey = false;
                $catNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catNamefield;

                $carDescTypefield = new ExactTarget_DataExtensionField();
                $carDescTypefield->Name = 'CategoryDescription';
                $carDescTypefield->IsPrimaryKey = false;
                $carDescTypefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $carDescTypefield;

                $catLabelfield = new ExactTarget_DataExtensionField();
                $catLabelfield->Name = 'CategoryLabel';
                $catLabelfield->IsPrimaryKey = false;
                $catLabelfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catLabelfield;

                $catParntIdfield = new ExactTarget_DataExtensionField();
                $catParntIdfield->Name = 'CategoryParentId';
                $catParntIdfield->IsPrimaryKey = false;
                $catParntIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catParntIdfield;

                $thumbNailImagefield = new ExactTarget_DataExtensionField();
                $thumbNailImagefield->Name = 'ThumbNamilImage';
                $thumbNailImagefield->IsPrimaryKey = false;
                $thumbNailImagefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $thumbNailImagefield;

                $object = new SoapVar($newde, SOAP_ENC_OBJECT, 'DataExtension', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = null;
                $request->Objects = array($object);
                $results = $client->Create($request);

                /* First Entry Data In DE */
                $catId                  = $category->getId() ?? '';
                $categoryName           = $category->getName() ?? '--';
                $categoryDescription    = $category->getDescription() ?? '--';
                $categoryDescription    = strip_tags($categoryDescription) ?? '--';
                $categoryUrl            = $category->getUrl() ?? '--';
                $categoryLevel          = $category->getLevel() ?? '--';
                $parentCategoryId       = $category->getParentId() ?? '--';

                $categoryIdElements     = explode('-', $catId);
                $category               = $this->_categoryRepository->get(end($categoryIdElements));
                $categoryUrl            = $category->getImageUrl() ?? '--';
                //$thumbHtml = '<img src="'.$categoryUrl.'"/>';

                $DE = new ExactTarget_DataExtensionObject();
                $DE->Name=$search;

                $apiPropertyCategoryID = new ExactTarget_APIProperty();
                $apiPropertyCategoryID->Name="CategoryID";
                $apiPropertyCategoryID->Value= '#'.$catId;
                $DE->Keys[] = $apiPropertyCategoryID;

                $apiPropertyCategoryName = new ExactTarget_APIProperty();
                $apiPropertyCategoryName->Name="CategoryName";
                $apiPropertyCategoryName->Value=ucwords($categoryName);

                $apiPropertyCategoryDescription = new ExactTarget_APIProperty();
                $apiPropertyCategoryDescription->Name="CategoryDescription";
                $apiPropertyCategoryDescription->Value=$categoryDescription;

                $apiPropertyCategoryLabel = new ExactTarget_APIProperty();
                $apiPropertyCategoryLabel->Name="CategoryLabel";
                $apiPropertyCategoryLabel->Value=$categoryLevel;

                $apiPropertyCategoryParentId = new ExactTarget_APIProperty();
                $apiPropertyCategoryParentId->Name="CategoryParentId";
                $apiPropertyCategoryParentId->Value=$parentCategoryId;

                $apiPropertyThumbNamilImage = new ExactTarget_APIProperty();
                $apiPropertyThumbNamilImage->Name="ThumbNamilImage";
                $apiPropertyThumbNamilImage->Value=$categoryUrl;


                $DE->Properties = array($apiPropertyCategoryName,$apiPropertyCategoryDescription,$apiPropertyCategoryLabel,$apiPropertyCategoryParentId,$apiPropertyThumbNamilImage);

                $so = new ExactTarget_SaveOption();
                $so->PropertyName = "*";
                $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                $opts = new ExactTarget_UpdateOptions();
                $opts->SaveOptions = array($soe);

                $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = $opts;
                $request->Objects = array($object);
                $outputs = $client->Update($request);
                if (!empty($outputs->Results->StatusCode)) {
                    if ($outputs->Results->StatusCode == 'Error') {
                        $result = false;
                        $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                    }
                }
                if ($result) {
                    $this
                    ->marketingCloudsyncLog('Category Auto Export Sucess : '.$catId . 'Category Exported Successfully to Maketing Cloud');
                } else {
                    $this
                    ->marketingCloudsyncLog('Category Auto Export Error : '.$catId . ' Not Exported '.$msg);
                }
            } else {
                /* First Entry Data In DE */
                $catId                  = $category->getId() ?? '';
                $categoryName           = $category->getName() ?? '--';
                $categoryDescription    = $category->getDescription() ?? '--';
                $categoryDescription    = strip_tags($categoryDescription) ?? '--';
                $categoryUrl            = $category->getUrl() ?? '--';
                $categoryLevel          = $category->getLevel() ?? '--';
                $parentCategoryId       = $category->getParentId() ?? '--';

                $categoryIdElements     = explode('-', $catId);
                $category               = $this->_categoryRepository->get(end($categoryIdElements));
                $categoryUrl            = $category->getImageUrl() ?? '--';

                $DE = new ExactTarget_DataExtensionObject();
                $DE->Name=$search;

                $apiPropertyCategoryID = new ExactTarget_APIProperty();
                $apiPropertyCategoryID->Name="CategoryID";
                $apiPropertyCategoryID->Value= '#'.$catId;
                $DE->Keys[] = $apiPropertyCategoryID;

                $apiPropertyCategoryName = new ExactTarget_APIProperty();
                $apiPropertyCategoryName->Name="CategoryName";
                $apiPropertyCategoryName->Value=ucwords($categoryName);

                $apiPropertyCategoryDescription = new ExactTarget_APIProperty();
                $apiPropertyCategoryDescription->Name="CategoryDescription";
                $apiPropertyCategoryDescription->Value=$categoryDescription;

                $apiPropertyCategoryLabel = new ExactTarget_APIProperty();
                $apiPropertyCategoryLabel->Name="CategoryLabel";
                $apiPropertyCategoryLabel->Value=$categoryLevel;

                $apiPropertyCategoryParentId = new ExactTarget_APIProperty();
                $apiPropertyCategoryParentId->Name="CategoryParentId";
                $apiPropertyCategoryParentId->Value=$parentCategoryId;

                $apiPropertyThumbNamilImage = new ExactTarget_APIProperty();
                $apiPropertyThumbNamilImage->Name="ThumbNamilImage";
                $apiPropertyThumbNamilImage->Value=$categoryUrl;

                $DE->Properties = array($apiPropertyCategoryName,$apiPropertyCategoryDescription,$apiPropertyCategoryLabel,$apiPropertyCategoryParentId,$apiPropertyThumbNamilImage);

                $so = new ExactTarget_SaveOption();
                $so->PropertyName = "*";
                $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                $opts = new ExactTarget_UpdateOptions();
                $opts->SaveOptions = array($soe);

                $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = $opts;
                $request->Objects = array($object);
                $outputs = $client->Update($request);
                if (!empty($outputs->Results->StatusCode)) {
                    if ($outputs->Results->StatusCode == 'Error') {
                        $result = false;
                        $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                    }
                }
                if ($result) {
                    $this
                    ->marketingCloudsyncLog('Category Auto Export Sucess : '.$catId . 'Category Exported Successfully to Maketing Cloud');
                } else {
                    $this
                    ->marketingCloudsyncLog('Category Auto Export Error : '.$catId . ' Not Exported '.$msg);
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Category Export Auto Exception : Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Category Export Auto ContextErrorException : Not Exported '.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
                ->marketingCloudsyncLog('Category Export Auto SoapFault : Not Exported '.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }

    public function getAutoSyncAllCategory($categoryIds)
    {
        $msg = '';
        $result= true;
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            //get Data extension List first
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "DataExtension";
            $rr->Properties = array("CustomerKey","Name","CategoryID","Status");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $results = $client->Retrieve($rrm);
            $results = $results->Results;
            /* Store All Folder name into an Array*/
            $allDEs = array();
            foreach ($results as $k=>$v) {
                $allDEs[$k] = $v->Name;
            }
            $search = "WkMagentoCategoryDE";
            if (!in_array($search, $allDEs)) {
                $newde = new ExactTarget_DataExtension();
                $newde->Name = $search;
                $newde->CustomerKey = $search;
                $newde->IsSendable = true;
                $newde->IsTestable = false;
                $newde->SendableDataExtensionField = new ExactTarget_DataExtensionField();
                $newde->SendableDataExtensionField->Name = 'CategoryID';
                $newde->SendableSubscriberField = new ExactTarget_Attribute();
                $newde->SendableSubscriberField->Name = 'Subscriber Key';
                $newde->SendableDataExtensionField->value = $search;

                $newde->Fields = array();
                $catIdfield = new ExactTarget_DataExtensionField();
                $catIdfield->Name = 'CategoryID';
                $catIdfield->IsPrimaryKey = true;
                $catIdfield->IsRequired = true;
                $catIdfield->MaxLength = 100;
                $catIdfield->MinLength = 0;
                $catIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catIdfield;

                $catNamefield = new ExactTarget_DataExtensionField();
                $catNamefield->Name = 'CategoryName';
                $catNamefield->IsPrimaryKey = false;
                $catNamefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catNamefield;

                $carDescTypefield = new ExactTarget_DataExtensionField();
                $carDescTypefield->Name = 'CategoryDescription';
                $carDescTypefield->IsPrimaryKey = false;
                $carDescTypefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $carDescTypefield;

                $catLabelfield = new ExactTarget_DataExtensionField();
                $catLabelfield->Name = 'CategoryLabel';
                $catLabelfield->IsPrimaryKey = false;
                $catLabelfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catLabelfield;

                $catParntIdfield = new ExactTarget_DataExtensionField();
                $catParntIdfield->Name = 'CategoryParentId';
                $catParntIdfield->IsPrimaryKey = false;
                $catParntIdfield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $catParntIdfield;

                $thumbNailImagefield = new ExactTarget_DataExtensionField();
                $thumbNailImagefield->Name = 'ThumbNamilImage';
                $thumbNailImagefield->IsPrimaryKey = false;
                $thumbNailImagefield->FieldType = ExactTarget_DataExtensionFieldType::Text;
                $newde->Fields[] = $thumbNailImagefield;

                $object = new SoapVar($newde, SOAP_ENC_OBJECT, 'DataExtension', "http://exacttarget.com/wsdl/partnerAPI");
                $request = new ExactTarget_CreateRequest();
                $request->Options = null;
                $request->Objects = array($object);
                $results = $client->Create($request);

                /* First Entry Data In DE */
                foreach ($categoryIds as $categoryId) {
                    $result = true;
                    $_objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $category = $_objectManager->create('Magento\Catalog\Model\Category')->load($categoryId);
                    /* First Entry Data In DE */
                    $catId                  = $category->getId() ?? '';
                    $categoryName           = $category->getName() ?? '--';
                    $categoryDescription    = $category->getDescription() ?? '--';
                    $categoryDescription    = strip_tags($categoryDescription) ?? '--';
                    $categoryUrl            = $category->getUrl() ?? '--';
                    $categoryLevel          = $category->getLevel() ?? '--';
                    $parentCategoryId       = $category->getParentId() ?? '--';

                    $categoryIdElements     = explode('-', $catId);
                    $category               = $this->_categoryRepository->get(end($categoryIdElements));
                    $categoryUrl            = $category->getImageUrl() ?? '--';
                    //$thumbHtml = '<img src="'.$categoryUrl.'"/>';

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyCategoryID = new ExactTarget_APIProperty();
                    $apiPropertyCategoryID->Name="CategoryID";
                    $apiPropertyCategoryID->Value= '#'.$catId;
                    $DE->Keys[] = $apiPropertyCategoryID;

                    $apiPropertyCategoryName = new ExactTarget_APIProperty();
                    $apiPropertyCategoryName->Name="CategoryName";
                    $apiPropertyCategoryName->Value=ucwords($categoryName);

                    $apiPropertyCategoryDescription = new ExactTarget_APIProperty();
                    $apiPropertyCategoryDescription->Name="CategoryDescription";
                    $apiPropertyCategoryDescription->Value=$categoryDescription;

                    $apiPropertyCategoryLabel = new ExactTarget_APIProperty();
                    $apiPropertyCategoryLabel->Name="CategoryLabel";
                    $apiPropertyCategoryLabel->Value=$categoryLevel;

                    $apiPropertyCategoryParentId = new ExactTarget_APIProperty();
                    $apiPropertyCategoryParentId->Name="CategoryParentId";
                    $apiPropertyCategoryParentId->Value=$parentCategoryId;

                    $apiPropertyThumbNamilImage = new ExactTarget_APIProperty();
                    $apiPropertyThumbNamilImage->Name="ThumbNamilImage";
                    $apiPropertyThumbNamilImage->Value=$categoryUrl;


                    $DE->Properties = array($apiPropertyCategoryName,$apiPropertyCategoryDescription,$apiPropertyCategoryLabel,$apiPropertyCategoryParentId,$apiPropertyThumbNamilImage);

                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Category Export Sucess : '.$categoryId . 'Category Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Category Export Error : '.$categoryId . ' Not Exported '.$msg);
                    }
                }
            } else {
                /* Second Entry Data In DE */
                foreach ($categoryIds as $categoryId) {
                    $result = true;
                    $_objectManager = \Magento\Framework\App\ObjectManager::getInstance();
                    $category = $_objectManager->create('Magento\Catalog\Model\Category')->load($categoryId);
                    /* First Entry Data In DE */
                    $catId                  = $category->getId() ?? '';
                    $categoryName           = $category->getName() ?? '--';
                    $categoryDescription    = $category->getDescription() ?? '--';
                    $categoryDescription    = strip_tags($categoryDescription) ?? '--';
                    $categoryUrl            = $category->getUrl() ?? '--';
                    $categoryLevel          = $category->getLevel() ?? '--';
                    $parentCategoryId       = $category->getParentId() ?? '--';

                    $categoryIdElements     = explode('-', $catId);
                    $category               = $this->_categoryRepository->get(end($categoryIdElements));
                    $categoryUrl            = $category->getImageUrl() ?? '--';
                    //$thumbHtml = '<img src="'.$categoryUrl.'"/>';

                    $DE = new ExactTarget_DataExtensionObject();
                    $DE->Name=$search;

                    $apiPropertyCategoryID = new ExactTarget_APIProperty();
                    $apiPropertyCategoryID->Name="CategoryID";
                    $apiPropertyCategoryID->Value= '#'.$catId;
                    $DE->Keys[] = $apiPropertyCategoryID;

                    $apiPropertyCategoryName = new ExactTarget_APIProperty();
                    $apiPropertyCategoryName->Name="CategoryName";
                    $apiPropertyCategoryName->Value=ucwords($categoryName);

                    $apiPropertyCategoryDescription = new ExactTarget_APIProperty();
                    $apiPropertyCategoryDescription->Name="CategoryDescription";
                    $apiPropertyCategoryDescription->Value=$categoryDescription;

                    $apiPropertyCategoryLabel = new ExactTarget_APIProperty();
                    $apiPropertyCategoryLabel->Name="CategoryLabel";
                    $apiPropertyCategoryLabel->Value=$categoryLevel;

                    $apiPropertyCategoryParentId = new ExactTarget_APIProperty();
                    $apiPropertyCategoryParentId->Name="CategoryParentId";
                    $apiPropertyCategoryParentId->Value=$parentCategoryId;

                    $apiPropertyThumbNamilImage = new ExactTarget_APIProperty();
                    $apiPropertyThumbNamilImage->Name="ThumbNamilImage";
                    $apiPropertyThumbNamilImage->Value=$categoryUrl;


                    $DE->Properties = array($apiPropertyCategoryName,$apiPropertyCategoryDescription,$apiPropertyCategoryLabel,$apiPropertyCategoryParentId,$apiPropertyThumbNamilImage);

                    $so = new ExactTarget_SaveOption();
                    $so->PropertyName = "*";
                    $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                    $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
                    $opts = new ExactTarget_UpdateOptions();
                    $opts->SaveOptions = array($soe);

                    $object = new SoapVar($DE, SOAP_ENC_OBJECT, 'DataExtensionObject', "http://exacttarget.com/wsdl/partnerAPI");
                    $request = new ExactTarget_CreateRequest();
                    $request->Options = $opts;
                    $request->Objects = array($object);
                    $outputs = $client->Update($request);
                    if (!empty($outputs->Results->StatusCode)) {
                        if ($outputs->Results->StatusCode == 'Error') {
                            $result = false;
                            $msg = 'Error code: '. $outputs->Results->ErrorCode . ' Error message: '.$outputs->Results->StatusMessage;
                        }
                    }
                    if ($result) {
                        $this
                        ->marketingCloudsyncLog('Category Export Sucess : '.$categoryId . 'Category Exported Successfully to Maketing Cloud');
                    } else {
                        $this
                        ->marketingCloudsyncLog('Category Export Error : '.$categoryId . ' Not Exported '.$msg);
                    }
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this
            ->marketingCloudsyncLog('Category Export Exception : Not Exported '.$msg);
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
            $this
            ->marketingCloudsyncLog('Category Export ContextErrorException : Not Exported '.$msg);
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
                $this
                ->marketingCloudsyncLog('Category Export SoapFault : Not Exported '.$msg);
            }
            //$msg = trigger_error("SOAP Fault: (faultcode: {$fault->faultcode}, faultstring: {$fault->faultstring})", E_USER_ERROR);
            $msg = $fault->getMessage();
        }
        return [$result, $msg];
    }
    public function importSubscriber()
    {
        $msg = '';
        $result= false;
        $list= array();
        $data = array();
        if (isset(self::$mcSubDomain)) {
            $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
        } else {
            $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
        }
        try {
            /* Create the Soap Client */
            $client = new ExactTargetSoapClient($wsdl, array('trace'=>1,'keep_alive' => false,'exceptions' => true));
            //$client = new ExactTargetSoapClient($wsdl,['trace' => 1, 'exceptions' => true]);
            /* Set username and password here */
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            // retuive subscribers using list id
            $rr = new ExactTarget_RetrieveRequest();
            $rr->ObjectType = "SubscriberList";
            $rr->Properties =  array();
            $rr->Properties[] = "ID";
            $rr->Properties[] = "List.ListName";
            $rr->Properties[] = "List.ID";
            $rr->Properties[] = "Status";
            $rr->Properties[] = "Subscriber.EmailAddress";
            $rr->Properties[] = "Subscriber.SubscriberKey";
            $sfp= new ExactTarget_SimpleFilterPart();
            $sfp->Value =  array(self::$mcList); // This is the ListID that you want to get the subscribers for
            $sfp->SimpleOperator = ExactTarget_SimpleOperators::equals;
            $sfp->Property="List.ID";
            $rr->Filter = new SoapVar($sfp, SOAP_ENC_OBJECT, 'SimpleFilterPart', "http://exacttarget.com/wsdl/partnerAPI");
            $rr->Options = null;
            $rrm = new ExactTarget_RetrieveRequestMsg();
            $rrm->RetrieveRequest = $rr;
            $oldresults = $client->Retrieve($rrm);
            $oldResultDatas = isset($oldresults->Results)? $oldresults->Results: null;
            $tryCount = '';
            $i=0;
            while ($oldresults->OverallStatus=="MoreDataAvailable") {
                $i++;
                $oldresultsTemp = WooSfMc::getRunRetrieveRequest($oldresults->RequestID, $client);
                $oldResultDataTemp = isset($oldresultsTemp->Results)? $oldresultsTemp->Results: null;
                if (!empty($oldResultDataTemp)) {
                    $oldResultDatas = array_merge($oldResultDataTemp, $oldResultDatas);
                }
                if ($i>1) {
                    break;
                }
            }

            foreach ($oldResultDatas as $result) {
                $data =[
                    'mc_subsListId'=>$result->List->ID,
                    'mc_subsListName'=>$result->List->ListName,
                    'mc_subsId'=>$result->ID,
                    'mc_subsEmail'=>$result->Subscriber->EmailAddress,
                    'mc_subsKey'=>$result->Subscriber->SubscriberKey,
                ];
                $list[] =$data;
            }
            $result= true;
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
        } catch (ContextErrorException $err) {
            $msg = $err->getMessage();
        } catch (SoapFault $fault) {
            if ($fault->faultstring == 'Could not connect to host') {
                $msg = $fault->faultstring;
            }
            $msg = $fault->getMessage();
        }
        return [$result, $msg, $list];
    }
    public function SyncSubscriberToList($collection)
    {
        $result = true;
        $msg = '';
        $listId = $this->_scopeConfig->getValue('marketingcloud/general/mc_list');
        if (!$listId) {
            $result = false;
            return $result;
        }
        try {
            if (isset(self::$mcUser) && isset(self::$mcPwd)) {
                if (isset(self::$mcSubDomain)) {
                    $wsdl = 'https://'.self::$mcSubDomain.'.soap.marketingcloudapis.com/ETFramework.wsdl';
                } else {
                    $wsdl = 'https://webservice.s7.exacttarget.com/etframework.wsdl';
                }
            }
            $client =  new ExactTargetSoapClient($wsdl, array('trace'=>1));
            $client->username = self::$mcUser;
            $client->password = $this->_encryptor->decrypt(self::$mcPwd);
            ;
            
            foreach ($collection as $subscriberId) {
                $result = true;
                $msg = '';
                $subscriber = $this->subscriberFactory->create()->load(
                    $subscriberId
                );
                $custId = $subscriber->getCustomerId();
                if ($custId) {
                    $customer = $this->_customerRepository->getById($custId);
                    $custFirstName = $customer->getFirstname();
                    $custLasttName = $customer->getLastname();
                } else {
                    $custFirstName = 'Guest';
                    $custLasttName = 'User';
                }
                $custEmail = $subscriber->getEmail();

                $subscriber = new ExactTarget_Subscriber();
                
                $subscriber->EmailAddress = $custEmail;
                $subscriber->SubscriberKey = $custEmail;
               
                
                $FirstNameAttribute = new ExactTarget_Attribute();
                $FirstNameAttribute->Name = "First Name";
                $FirstNameAttribute->Value = $custFirstName;
                
                $LastNameAttribute = new ExactTarget_Attribute();
                $LastNameAttribute->Name = "Last Name";
                $LastNameAttribute->Value = $custLasttName;

                $subscriber->Attributes=array($FirstNameAttribute,$LastNameAttribute);

                $subscriber->Lists = array();
                $list = new ExactTarget_SubscriberList();
                $list->ID = $listId;
                $subscriber->Lists[] = $list;
                
                $so = new ExactTarget_SaveOption();
                $so->PropertyName = "*";
                $so->SaveAction = ExactTarget_SaveAction::UpdateAdd;
                $soe = new SoapVar($so, SOAP_ENC_OBJECT, 'SaveOption', "http://exacttarget.com/wsdl/partnerAPI");
               
                $opts = new ExactTarget_UpdateOptions();
                $opts->SaveOptions = array($soe);

                $object = new SoapVar($subscriber, SOAP_ENC_OBJECT, 'Subscriber', "http://exacttarget.com/wsdl/partnerAPI");
               
                $request = new ExactTarget_CreateRequest();
                $request->Options = $opts;
                $request->Objects = array($object);
                $results = $client->Create($request);
                if (!empty($results->Results->StatusCode)) {
                    if ($results->Results->StatusCode == 'Error') {
                        $result = false;
                        $msg = 'Error code: '. $results->Results->ErrorCode . ' Error message: '.$results->Results->StatusMessage;
                    }
                }
                if ($result) {
                    $this
                    ->marketingCloudsyncLog('Subscriber Export Sucess : '.$subscriberId . ' Exported Successfully to Maketing Cloud');
                } else {
                    $this
                    ->marketingCloudsyncLog('Subscriber Export Error : '.$subscriberId . ' Not Exported '.$msg);
                }
            }
        } catch (\Exception $ee) {
            $msg = $ee->getMessage();
            $this->marketingCloudsyncLog('Subscriber Export Exception : Not Exported '.$msg);
            // print_r($ee);
        }
        return [$result,$msg];
    }
}
